package io.fabric8.kubernetes.api.model;

import io.fabric8.openshift.api.model.DeploymentConfigBuilder;
import io.fabric8.openshift.api.model.IdentityList;
import java.lang.String;
import io.fabric8.kubernetes.api.model.extensions.ScaleFluent;
import io.fabric8.openshift.api.model.IdentityFluent;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionListFluent;
import io.fabric8.openshift.api.model.OAuthAccessTokenBuilder;
import io.fabric8.openshift.api.model.OAuthAccessTokenListFluent;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSetListBuilder;
import com.fasterxml.jackson.databind.SerializerProvider;
import io.fabric8.openshift.api.model.ClusterPolicyBindingFluent;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionStatusBuilder;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionCondition;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionList;
import io.fabric8.kubernetes.api.model.authorization.SubjectAccessReviewBuilder;
import io.fabric8.openshift.api.model.BuildConfigListBuilder;
import io.fabric8.kubernetes.api.model.extensions.NetworkPolicyFluent;
import io.fabric8.openshift.api.model.OAuthAccessToken;
import io.fabric8.openshift.api.model.DeploymentConfig;
import io.fabric8.openshift.api.model.PolicyBindingListBuilder;
import io.fabric8.kubernetes.api.model.extensions.PodSecurityPolicyList;
import io.fabric8.openshift.api.model.OAuthClientBuilder;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionNamesFluent;
import io.fabric8.kubernetes.api.model.extensions.DaemonSetList;
import java.lang.Deprecated;
import io.fabric8.openshift.api.model.ProjectList;
import io.fabric8.kubernetes.api.model.extensions.PodSecurityPolicy;
import io.fabric8.kubernetes.api.model.extensions.NetworkPolicyListFluent;
import io.fabric8.openshift.api.model.SecurityContextConstraints;
import io.fabric8.openshift.api.model.OAuthAuthorizeTokenBuilder;
import io.fabric8.kubernetes.api.model.policy.PodDisruptionBudgetFluent;
import io.fabric8.openshift.api.model.OAuthAccessTokenFluent;
import io.fabric8.kubernetes.api.model.authorization.LocalSubjectAccessReviewBuilder;
import io.fabric8.openshift.api.model.RoleBindingList;
import io.fabric8.kubernetes.api.model.extensions.NetworkPolicyList;
import io.fabric8.kubernetes.api.model.extensions.Deployment;
import io.fabric8.openshift.api.model.GroupListBuilder;
import io.fabric8.kubernetes.api.model.extensions.DaemonSetFluent;
import io.fabric8.openshift.api.model.ClusterPolicyBindingListFluent;
import io.fabric8.openshift.api.model.GroupList;
import io.fabric8.kubernetes.api.model.extensions.IngressListFluent;
import io.fabric8.openshift.api.model.PolicyBindingFluent;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResourceFluent;
import java.lang.Override;
import io.fabric8.openshift.api.model.BuildListBuilder;
import io.fabric8.openshift.api.model.ClusterRoleBindingBuilder;
import io.fabric8.openshift.api.model.SecurityContextConstraintsListFluent;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResourceListFluent;
import io.fabric8.kubernetes.api.model.extensions.StatefulSetFluent;
import io.fabric8.openshift.api.model.OAuthAuthorizeToken;
import io.fabric8.openshift.api.model.Role;
import io.fabric8.openshift.api.model.ProjectBuilder;
import io.fabric8.openshift.api.model.OAuthClientAuthorizationBuilder;
import io.fabric8.kubernetes.api.model.policy.PodDisruptionBudgetListBuilder;
import io.fabric8.openshift.api.model.ImageListFluent;
import io.fabric8.openshift.api.model.ImageStreamTagListFluent;
import io.fabric8.kubernetes.api.model.extensions.IngressList;
import io.fabric8.openshift.api.model.ProjectListFluent;
import io.fabric8.openshift.api.model.PolicyList;
import io.fabric8.openshift.api.model.UserList;
import com.fasterxml.jackson.core.JsonParser;
import io.fabric8.openshift.api.model.ClusterRoleBindingListFluent;
import io.fabric8.openshift.api.model.ClusterPolicyBindingList;
import io.fabric8.openshift.api.model.SecurityContextConstraintsList;
import io.fabric8.kubernetes.api.model.version.Info;
import io.fabric8.kubernetes.api.model.authorization.LocalSubjectAccessReview;
import io.fabric8.openshift.api.model.RoleBuilder;
import io.fabric8.openshift.api.model.ProjectRequestBuilder;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionConditionBuilder;
import io.fabric8.kubernetes.api.model.authentication.TokenReviewFluent;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionSpecFluent;
import io.fabric8.openshift.api.model.OAuthAuthorizeTokenFluent;
import io.fabric8.kubernetes.api.model.extensions.StatefulSetList;
import io.fabric8.openshift.api.model.SecurityContextConstraintsBuilder;
import io.fabric8.kubernetes.api.model.extensions.NetworkPolicy;
import io.fabric8.openshift.api.model.ClusterPolicyFluent;
import io.fabric8.openshift.api.model.OAuthClientAuthorizationListFluent;
import io.fabric8.openshift.api.model.RoleListBuilder;
import java.util.Map;
import io.fabric8.kubernetes.api.model.extensions.DeploymentBuilder;
import io.fabric8.openshift.api.model.ImageListBuilder;
import io.fabric8.kubernetes.api.model.version.InfoBuilder;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResource;
import io.fabric8.openshift.api.model.TagEventBuilder;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionSpec;
import io.fabric8.kubernetes.api.model.authentication.TokenReviewBuilder;
import io.fabric8.openshift.api.model.RoleBindingRestriction;
import io.fabric8.openshift.api.model.OAuthClientAuthorizationListBuilder;
import io.fabric8.openshift.api.model.ClusterPolicyBuilder;
import io.fabric8.kubernetes.api.model.extensions.PodSecurityPolicyListBuilder;
import io.fabric8.kubernetes.api.model.extensions.DeploymentRollbackBuilder;
import io.fabric8.openshift.api.model.RouteListFluent;
import io.fabric8.openshift.api.model.ClusterRoleBindingList;
import io.fabric8.kubernetes.api.model.authentication.TokenReview;
import io.fabric8.openshift.api.model.TagEventFluent;
import io.fabric8.openshift.api.model.OAuthAccessTokenList;
import io.fabric8.openshift.api.model.DeploymentConfigListBuilder;
import io.fabric8.openshift.api.model.SecurityContextConstraintsListBuilder;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionBuilder;
import io.fabric8.openshift.api.model.TemplateBuilder;
import io.fabric8.kubernetes.api.model.extensions.IngressFluent;
import io.fabric8.kubernetes.api.model.policy.PodDisruptionBudgetBuilder;
import io.fabric8.openshift.api.model.Template;
import io.fabric8.openshift.api.model.OAuthAuthorizeTokenList;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResourceBuilder;
import io.fabric8.openshift.api.model.ClusterPolicyBindingBuilder;
import io.fabric8.openshift.api.model.ProjectListBuilder;
import io.fabric8.openshift.api.model.RoleList;
import io.fabric8.kubernetes.api.model.extensions.Ingress;
import io.fabric8.openshift.api.model.IdentityBuilder;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionConditionFluent;
import io.fabric8.openshift.api.model.GroupListFluent;
import io.fabric8.openshift.api.model.OAuthClient;
import io.fabric8.kubernetes.api.model.extensions.DaemonSetBuilder;
import io.fabric8.kubernetes.api.model.authorization.SubjectAccessReviewFluent;
import io.fabric8.openshift.api.model.OAuthClientAuthorizationList;
import com.fasterxml.jackson.databind.DeserializationContext;
import io.fabric8.openshift.api.model.ClusterRoleBindingListBuilder;
import io.fabric8.kubernetes.api.model.authorization.LocalSubjectAccessReviewFluent;
import io.fabric8.kubernetes.api.model.extensions.DeploymentRollback;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinition;
import io.fabric8.kubernetes.api.model.extensions.StatefulSetListFluent;
import io.fabric8.kubernetes.api.model.extensions.Scale;
import io.fabric8.kubernetes.api.model.extensions.PodSecurityPolicyBuilder;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionStatusFluent;
import io.fabric8.openshift.api.model.PolicyBindingList;
import io.fabric8.openshift.api.model.SubjectAccessReviewResponse;
import io.fabric8.openshift.api.model.ClusterRoleBinding;
import io.fabric8.openshift.api.model.UserBuilder;
import io.fabric8.kubernetes.api.model.extensions.NetworkPolicyBuilder;
import io.fabric8.openshift.api.model.BuildRequestFluent;
import io.fabric8.openshift.api.model.Project;
import io.fabric8.openshift.api.model.PolicyFluent;
import io.fabric8.openshift.api.model.PolicyBindingBuilder;
import io.fabric8.openshift.api.model.OAuthClientAuthorization;
import io.fabric8.openshift.api.model.Group;
import io.fabric8.openshift.api.model.RouteListBuilder;
import io.fabric8.openshift.api.model.RouteBuilder;
import io.fabric8.openshift.api.model.IdentityListFluent;
import io.fabric8.kubernetes.api.model.authorization.SubjectAccessReview;
import io.fabric8.kubernetes.api.model.extensions.StatefulSetBuilder;
import io.fabric8.kubernetes.api.model.extensions.DeploymentListBuilder;
import io.fabric8.kubernetes.api.model.extensions.DeploymentRollbackFluent;
import io.fabric8.kubernetes.api.model.policy.PodDisruptionBudgetList;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSet;
import io.fabric8.openshift.api.model.ClusterRoleBindingFluent;
import io.fabric8.openshift.api.model.BuildConfigListFluent;
import io.fabric8.kubernetes.api.model.extensions.PodSecurityPolicyFluent;
import io.fabric8.openshift.api.model.ProjectRequestFluent;
import io.fabric8.openshift.api.model.GroupBuilder;
import io.fabric8.kubernetes.api.model.policy.PodDisruptionBudgetListFluent;
import io.fabric8.kubernetes.api.model.extensions.PodSecurityPolicyListFluent;
import io.fabric8.openshift.api.model.IdentityListBuilder;
import io.fabric8.openshift.api.model.Route;
import io.fabric8.kubernetes.api.model.extensions.IngressListBuilder;
import io.fabric8.openshift.api.model.OAuthAuthorizeTokenListBuilder;
import java.lang.Long;
import io.fabric8.kubernetes.api.model.extensions.DaemonSet;
import io.fabric8.openshift.api.model.ClusterPolicyBindingListBuilder;
import io.fabric8.openshift.api.model.BuildConfigList;
import io.fabric8.openshift.api.model.OAuthClientFluent;
import io.fabric8.openshift.api.model.SecurityContextConstraintsFluent;
import io.fabric8.openshift.api.model.UserListFluent;
import com.fasterxml.jackson.databind.JsonSerializer;
import io.fabric8.kubernetes.api.model.extensions.DaemonSetListBuilder;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSetListFluent;
import io.fabric8.kubernetes.api.model.extensions.DeploymentFluent;
import io.fabric8.openshift.api.model.OAuthClientList;
import io.fabric8.openshift.api.model.ProjectFluent;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionFluent;
import io.fabric8.openshift.api.model.DeploymentConfigList;
import io.fabric8.openshift.api.model.PolicyBinding;
import io.fabric8.openshift.api.model.RoleFluent;
import io.fabric8.kubernetes.api.model.extensions.IngressBuilder;
import io.fabric8.openshift.api.model.UserFluent;
import io.fabric8.openshift.api.model.RoleBindingRestrictionFluent;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.openshift.api.model.DeploymentConfigFluent;
import io.fabric8.kubernetes.api.model.version.InfoFluent;
import io.fabric8.openshift.api.model.RouteList;
import com.fasterxml.jackson.databind.JsonDeserializer;
import io.fabric8.kubernetes.api.model.extensions.NetworkPolicyListBuilder;
import io.fabric8.openshift.api.model.BuildRequestBuilder;
import io.fabric8.openshift.api.model.ClusterPolicyListFluent;
import io.fabric8.openshift.api.model.Identity;
import java.lang.Boolean;
import io.fabric8.openshift.api.model.UserListBuilder;
import io.fabric8.openshift.api.model.ClusterPolicyListBuilder;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionNamesBuilder;
import io.fabric8.kubernetes.api.model.extensions.DaemonSetListFluent;
import io.fabric8.openshift.api.model.ImageStreamList;
import io.fabric8.openshift.api.model.PolicyListBuilder;
import io.fabric8.openshift.api.model.RoleBindingRestrictionBuilder;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSetList;
import javax.validation.Valid;
import io.fabric8.openshift.api.model.ProjectRequest;
import java.lang.Object;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResourceListBuilder;
import io.fabric8.openshift.api.model.OAuthAccessTokenListBuilder;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionSpecBuilder;
import io.fabric8.openshift.api.model.ImageStreamTagList;
import io.fabric8.openshift.api.model.TemplateListBuilder;
import io.fabric8.openshift.api.model.GroupFluent;
import com.fasterxml.jackson.core.JsonGenerator;
import io.fabric8.openshift.api.model.RoleBindingListBuilder;
import io.fabric8.openshift.api.model.DeploymentConfigListFluent;
import io.fabric8.openshift.api.model.PolicyBindingListFluent;
import io.fabric8.openshift.api.model.ClusterPolicy;
import io.fabric8.openshift.api.model.RoleBindingFluent;
import io.fabric8.openshift.api.model.OAuthClientAuthorizationFluent;
import io.fabric8.openshift.api.model.RoleListFluent;
import io.fabric8.kubernetes.api.model.extensions.StatefulSetListBuilder;
import io.fabric8.openshift.api.model.ImageList;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionListBuilder;
import io.fabric8.openshift.api.model.TemplateListFluent;
import io.fabric8.openshift.api.model.RouteFluent;
import io.fabric8.openshift.api.model.Policy;
import io.fabric8.openshift.api.model.SubjectAccessReviewResponseBuilder;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionStatus;
import io.fabric8.openshift.api.model.OAuthAuthorizeTokenListFluent;
import io.fabric8.openshift.api.model.PolicyListFluent;
import io.fabric8.openshift.api.model.SubjectAccessReviewResponseFluent;
import io.fabric8.openshift.api.model.ClusterPolicyList;
import io.fabric8.openshift.api.model.RoleBinding;
import io.fabric8.openshift.api.model.PolicyBuilder;
import io.fabric8.kubernetes.api.model.extensions.ScaleBuilder;
import io.fabric8.openshift.api.model.BuildListFluent;
import io.fabric8.openshift.api.model.ImageStreamListBuilder;
import io.fabric8.openshift.api.model.RoleBindingBuilder;
import io.fabric8.openshift.api.model.OAuthClientListFluent;
import io.fabric8.openshift.api.model.TagEvent;
import io.fabric8.kubernetes.api.builder.Fluent;
import io.fabric8.openshift.api.model.BuildRequest;
import io.fabric8.kubernetes.api.model.extensions.DeploymentListFluent;
import io.fabric8.kubernetes.api.model.extensions.StatefulSet;
import io.fabric8.openshift.api.model.TemplateList;
import io.fabric8.openshift.api.model.User;
import io.fabric8.kubernetes.api.model.policy.PodDisruptionBudget;
import io.fabric8.kubernetes.api.builder.Nested;
import io.fabric8.openshift.api.model.ImageStreamListFluent;
import io.fabric8.kubernetes.api.model.extensions.DeploymentList;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSetFluent;
import io.fabric8.kubernetes.api.model.extensions.ThirdPartyResourceList;
import io.fabric8.openshift.api.model.TemplateFluent;
import io.fabric8.openshift.api.model.ClusterPolicyBinding;
import io.fabric8.kubernetes.api.model.apiextensions.CustomResourceDefinitionNames;
import io.fabric8.kubernetes.api.model.extensions.ReplicaSetBuilder;
import io.fabric8.openshift.api.model.BuildList;
import io.fabric8.openshift.api.model.OAuthClientListBuilder;
import io.fabric8.openshift.api.model.RoleBindingListFluent;
import io.fabric8.openshift.api.model.ImageStreamTagListBuilder;

public interface KubeSchemaFluent<A extends KubeSchemaFluent<A>> extends Fluent<A>{


    
/**
 * This method has been deprecated, please use method buildBaseKubernetesList instead.
 */
@Deprecated public BaseKubernetesList getBaseKubernetesList();
    public BaseKubernetesList buildBaseKubernetesList();
    public A withBaseKubernetesList(BaseKubernetesList baseKubernetesList);
    public Boolean hasBaseKubernetesList();
    public KubeSchemaFluent.BaseKubernetesListNested<A> withNewBaseKubernetesList();
    public KubeSchemaFluent.BaseKubernetesListNested<A> withNewBaseKubernetesListLike(BaseKubernetesList item);
    public KubeSchemaFluent.BaseKubernetesListNested<A> editBaseKubernetesList();
    public KubeSchemaFluent.BaseKubernetesListNested<A> editOrNewBaseKubernetesList();
    public KubeSchemaFluent.BaseKubernetesListNested<A> editOrNewBaseKubernetesListLike(BaseKubernetesList item);
    
/**
 * This method has been deprecated, please use method buildBinding instead.
 */
@Deprecated public Binding getBinding();
    public Binding buildBinding();
    public A withBinding(Binding binding);
    public Boolean hasBinding();
    public KubeSchemaFluent.BindingNested<A> withNewBinding();
    public KubeSchemaFluent.BindingNested<A> withNewBindingLike(Binding item);
    public KubeSchemaFluent.BindingNested<A> editBinding();
    public KubeSchemaFluent.BindingNested<A> editOrNewBinding();
    public KubeSchemaFluent.BindingNested<A> editOrNewBindingLike(Binding item);
    
/**
 * This method has been deprecated, please use method buildBuildConfigList instead.
 */
@Deprecated public BuildConfigList getBuildConfigList();
    public BuildConfigList buildBuildConfigList();
    public A withBuildConfigList(BuildConfigList buildConfigList);
    public Boolean hasBuildConfigList();
    public KubeSchemaFluent.BuildConfigListNested<A> withNewBuildConfigList();
    public KubeSchemaFluent.BuildConfigListNested<A> withNewBuildConfigListLike(BuildConfigList item);
    public KubeSchemaFluent.BuildConfigListNested<A> editBuildConfigList();
    public KubeSchemaFluent.BuildConfigListNested<A> editOrNewBuildConfigList();
    public KubeSchemaFluent.BuildConfigListNested<A> editOrNewBuildConfigListLike(BuildConfigList item);
    
/**
 * This method has been deprecated, please use method buildBuildList instead.
 */
@Deprecated public BuildList getBuildList();
    public BuildList buildBuildList();
    public A withBuildList(BuildList buildList);
    public Boolean hasBuildList();
    public KubeSchemaFluent.BuildListNested<A> withNewBuildList();
    public KubeSchemaFluent.BuildListNested<A> withNewBuildListLike(BuildList item);
    public KubeSchemaFluent.BuildListNested<A> editBuildList();
    public KubeSchemaFluent.BuildListNested<A> editOrNewBuildList();
    public KubeSchemaFluent.BuildListNested<A> editOrNewBuildListLike(BuildList item);
    
/**
 * This method has been deprecated, please use method buildBuildRequest instead.
 */
@Deprecated public BuildRequest getBuildRequest();
    public BuildRequest buildBuildRequest();
    public A withBuildRequest(BuildRequest buildRequest);
    public Boolean hasBuildRequest();
    public KubeSchemaFluent.BuildRequestNested<A> withNewBuildRequest();
    public KubeSchemaFluent.BuildRequestNested<A> withNewBuildRequestLike(BuildRequest item);
    public KubeSchemaFluent.BuildRequestNested<A> editBuildRequest();
    public KubeSchemaFluent.BuildRequestNested<A> editOrNewBuildRequest();
    public KubeSchemaFluent.BuildRequestNested<A> editOrNewBuildRequestLike(BuildRequest item);
    
/**
 * This method has been deprecated, please use method buildClusterPolicy instead.
 */
@Deprecated public ClusterPolicy getClusterPolicy();
    public ClusterPolicy buildClusterPolicy();
    public A withClusterPolicy(ClusterPolicy clusterPolicy);
    public Boolean hasClusterPolicy();
    public KubeSchemaFluent.ClusterPolicyNested<A> withNewClusterPolicy();
    public KubeSchemaFluent.ClusterPolicyNested<A> withNewClusterPolicyLike(ClusterPolicy item);
    public KubeSchemaFluent.ClusterPolicyNested<A> editClusterPolicy();
    public KubeSchemaFluent.ClusterPolicyNested<A> editOrNewClusterPolicy();
    public KubeSchemaFluent.ClusterPolicyNested<A> editOrNewClusterPolicyLike(ClusterPolicy item);
    
/**
 * This method has been deprecated, please use method buildClusterPolicyBinding instead.
 */
@Deprecated public ClusterPolicyBinding getClusterPolicyBinding();
    public ClusterPolicyBinding buildClusterPolicyBinding();
    public A withClusterPolicyBinding(ClusterPolicyBinding clusterPolicyBinding);
    public Boolean hasClusterPolicyBinding();
    public KubeSchemaFluent.ClusterPolicyBindingNested<A> withNewClusterPolicyBinding();
    public KubeSchemaFluent.ClusterPolicyBindingNested<A> withNewClusterPolicyBindingLike(ClusterPolicyBinding item);
    public KubeSchemaFluent.ClusterPolicyBindingNested<A> editClusterPolicyBinding();
    public KubeSchemaFluent.ClusterPolicyBindingNested<A> editOrNewClusterPolicyBinding();
    public KubeSchemaFluent.ClusterPolicyBindingNested<A> editOrNewClusterPolicyBindingLike(ClusterPolicyBinding item);
    
/**
 * This method has been deprecated, please use method buildClusterPolicyBindingList instead.
 */
@Deprecated public ClusterPolicyBindingList getClusterPolicyBindingList();
    public ClusterPolicyBindingList buildClusterPolicyBindingList();
    public A withClusterPolicyBindingList(ClusterPolicyBindingList clusterPolicyBindingList);
    public Boolean hasClusterPolicyBindingList();
    public KubeSchemaFluent.ClusterPolicyBindingListNested<A> withNewClusterPolicyBindingList();
    public KubeSchemaFluent.ClusterPolicyBindingListNested<A> withNewClusterPolicyBindingListLike(ClusterPolicyBindingList item);
    public KubeSchemaFluent.ClusterPolicyBindingListNested<A> editClusterPolicyBindingList();
    public KubeSchemaFluent.ClusterPolicyBindingListNested<A> editOrNewClusterPolicyBindingList();
    public KubeSchemaFluent.ClusterPolicyBindingListNested<A> editOrNewClusterPolicyBindingListLike(ClusterPolicyBindingList item);
    
/**
 * This method has been deprecated, please use method buildClusterPolicyList instead.
 */
@Deprecated public ClusterPolicyList getClusterPolicyList();
    public ClusterPolicyList buildClusterPolicyList();
    public A withClusterPolicyList(ClusterPolicyList clusterPolicyList);
    public Boolean hasClusterPolicyList();
    public KubeSchemaFluent.ClusterPolicyListNested<A> withNewClusterPolicyList();
    public KubeSchemaFluent.ClusterPolicyListNested<A> withNewClusterPolicyListLike(ClusterPolicyList item);
    public KubeSchemaFluent.ClusterPolicyListNested<A> editClusterPolicyList();
    public KubeSchemaFluent.ClusterPolicyListNested<A> editOrNewClusterPolicyList();
    public KubeSchemaFluent.ClusterPolicyListNested<A> editOrNewClusterPolicyListLike(ClusterPolicyList item);
    
/**
 * This method has been deprecated, please use method buildClusterRoleBinding instead.
 */
@Deprecated public ClusterRoleBinding getClusterRoleBinding();
    public ClusterRoleBinding buildClusterRoleBinding();
    public A withClusterRoleBinding(ClusterRoleBinding clusterRoleBinding);
    public Boolean hasClusterRoleBinding();
    public KubeSchemaFluent.ClusterRoleBindingNested<A> withNewClusterRoleBinding();
    public KubeSchemaFluent.ClusterRoleBindingNested<A> withNewClusterRoleBindingLike(ClusterRoleBinding item);
    public KubeSchemaFluent.ClusterRoleBindingNested<A> editClusterRoleBinding();
    public KubeSchemaFluent.ClusterRoleBindingNested<A> editOrNewClusterRoleBinding();
    public KubeSchemaFluent.ClusterRoleBindingNested<A> editOrNewClusterRoleBindingLike(ClusterRoleBinding item);
    
/**
 * This method has been deprecated, please use method buildClusterRoleBindingList instead.
 */
@Deprecated public ClusterRoleBindingList getClusterRoleBindingList();
    public ClusterRoleBindingList buildClusterRoleBindingList();
    public A withClusterRoleBindingList(ClusterRoleBindingList clusterRoleBindingList);
    public Boolean hasClusterRoleBindingList();
    public KubeSchemaFluent.ClusterRoleBindingListNested<A> withNewClusterRoleBindingList();
    public KubeSchemaFluent.ClusterRoleBindingListNested<A> withNewClusterRoleBindingListLike(ClusterRoleBindingList item);
    public KubeSchemaFluent.ClusterRoleBindingListNested<A> editClusterRoleBindingList();
    public KubeSchemaFluent.ClusterRoleBindingListNested<A> editOrNewClusterRoleBindingList();
    public KubeSchemaFluent.ClusterRoleBindingListNested<A> editOrNewClusterRoleBindingListLike(ClusterRoleBindingList item);
    
/**
 * This method has been deprecated, please use method buildComponentStatusList instead.
 */
@Deprecated public ComponentStatusList getComponentStatusList();
    public ComponentStatusList buildComponentStatusList();
    public A withComponentStatusList(ComponentStatusList componentStatusList);
    public Boolean hasComponentStatusList();
    public KubeSchemaFluent.ComponentStatusListNested<A> withNewComponentStatusList();
    public KubeSchemaFluent.ComponentStatusListNested<A> withNewComponentStatusListLike(ComponentStatusList item);
    public KubeSchemaFluent.ComponentStatusListNested<A> editComponentStatusList();
    public KubeSchemaFluent.ComponentStatusListNested<A> editOrNewComponentStatusList();
    public KubeSchemaFluent.ComponentStatusListNested<A> editOrNewComponentStatusListLike(ComponentStatusList item);
    
/**
 * This method has been deprecated, please use method buildConfig instead.
 */
@Deprecated public Config getConfig();
    public Config buildConfig();
    public A withConfig(Config config);
    public Boolean hasConfig();
    public KubeSchemaFluent.ConfigNested<A> withNewConfig();
    public KubeSchemaFluent.ConfigNested<A> withNewConfigLike(Config item);
    public KubeSchemaFluent.ConfigNested<A> editConfig();
    public KubeSchemaFluent.ConfigNested<A> editOrNewConfig();
    public KubeSchemaFluent.ConfigNested<A> editOrNewConfigLike(Config item);
    
/**
 * This method has been deprecated, please use method buildConfigMap instead.
 */
@Deprecated public ConfigMap getConfigMap();
    public ConfigMap buildConfigMap();
    public A withConfigMap(ConfigMap configMap);
    public Boolean hasConfigMap();
    public KubeSchemaFluent.ConfigMapNested<A> withNewConfigMap();
    public KubeSchemaFluent.ConfigMapNested<A> withNewConfigMapLike(ConfigMap item);
    public KubeSchemaFluent.ConfigMapNested<A> editConfigMap();
    public KubeSchemaFluent.ConfigMapNested<A> editOrNewConfigMap();
    public KubeSchemaFluent.ConfigMapNested<A> editOrNewConfigMapLike(ConfigMap item);
    
/**
 * This method has been deprecated, please use method buildConfigMapList instead.
 */
@Deprecated public ConfigMapList getConfigMapList();
    public ConfigMapList buildConfigMapList();
    public A withConfigMapList(ConfigMapList configMapList);
    public Boolean hasConfigMapList();
    public KubeSchemaFluent.ConfigMapListNested<A> withNewConfigMapList();
    public KubeSchemaFluent.ConfigMapListNested<A> withNewConfigMapListLike(ConfigMapList item);
    public KubeSchemaFluent.ConfigMapListNested<A> editConfigMapList();
    public KubeSchemaFluent.ConfigMapListNested<A> editOrNewConfigMapList();
    public KubeSchemaFluent.ConfigMapListNested<A> editOrNewConfigMapListLike(ConfigMapList item);
    
/**
 * This method has been deprecated, please use method buildContainerStatus instead.
 */
@Deprecated public ContainerStatus getContainerStatus();
    public ContainerStatus buildContainerStatus();
    public A withContainerStatus(ContainerStatus containerStatus);
    public Boolean hasContainerStatus();
    public KubeSchemaFluent.ContainerStatusNested<A> withNewContainerStatus();
    public KubeSchemaFluent.ContainerStatusNested<A> withNewContainerStatusLike(ContainerStatus item);
    public KubeSchemaFluent.ContainerStatusNested<A> editContainerStatus();
    public KubeSchemaFluent.ContainerStatusNested<A> editOrNewContainerStatus();
    public KubeSchemaFluent.ContainerStatusNested<A> editOrNewContainerStatusLike(ContainerStatus item);
    
/**
 * This method has been deprecated, please use method buildCronJob instead.
 */
@Deprecated public CronJob getCronJob();
    public CronJob buildCronJob();
    public A withCronJob(CronJob cronJob);
    public Boolean hasCronJob();
    public KubeSchemaFluent.CronJobNested<A> withNewCronJob();
    public KubeSchemaFluent.CronJobNested<A> withNewCronJobLike(CronJob item);
    public KubeSchemaFluent.CronJobNested<A> editCronJob();
    public KubeSchemaFluent.CronJobNested<A> editOrNewCronJob();
    public KubeSchemaFluent.CronJobNested<A> editOrNewCronJobLike(CronJob item);
    
/**
 * This method has been deprecated, please use method buildCronJobList instead.
 */
@Deprecated public CronJobList getCronJobList();
    public CronJobList buildCronJobList();
    public A withCronJobList(CronJobList cronJobList);
    public Boolean hasCronJobList();
    public KubeSchemaFluent.CronJobListNested<A> withNewCronJobList();
    public KubeSchemaFluent.CronJobListNested<A> withNewCronJobListLike(CronJobList item);
    public KubeSchemaFluent.CronJobListNested<A> editCronJobList();
    public KubeSchemaFluent.CronJobListNested<A> editOrNewCronJobList();
    public KubeSchemaFluent.CronJobListNested<A> editOrNewCronJobListLike(CronJobList item);
    
/**
 * This method has been deprecated, please use method buildCustomResourceDefinition instead.
 */
@Deprecated public CustomResourceDefinition getCustomResourceDefinition();
    public CustomResourceDefinition buildCustomResourceDefinition();
    public A withCustomResourceDefinition(CustomResourceDefinition customResourceDefinition);
    public Boolean hasCustomResourceDefinition();
    public KubeSchemaFluent.CustomResourceDefinitionNested<A> withNewCustomResourceDefinition();
    public KubeSchemaFluent.CustomResourceDefinitionNested<A> withNewCustomResourceDefinitionLike(CustomResourceDefinition item);
    public KubeSchemaFluent.CustomResourceDefinitionNested<A> editCustomResourceDefinition();
    public KubeSchemaFluent.CustomResourceDefinitionNested<A> editOrNewCustomResourceDefinition();
    public KubeSchemaFluent.CustomResourceDefinitionNested<A> editOrNewCustomResourceDefinitionLike(CustomResourceDefinition item);
    
/**
 * This method has been deprecated, please use method buildCustomResourceDefinitionCondition instead.
 */
@Deprecated public CustomResourceDefinitionCondition getCustomResourceDefinitionCondition();
    public CustomResourceDefinitionCondition buildCustomResourceDefinitionCondition();
    public A withCustomResourceDefinitionCondition(CustomResourceDefinitionCondition customResourceDefinitionCondition);
    public Boolean hasCustomResourceDefinitionCondition();
    public KubeSchemaFluent.CustomResourceDefinitionConditionNested<A> withNewCustomResourceDefinitionCondition();
    public KubeSchemaFluent.CustomResourceDefinitionConditionNested<A> withNewCustomResourceDefinitionConditionLike(CustomResourceDefinitionCondition item);
    public KubeSchemaFluent.CustomResourceDefinitionConditionNested<A> editCustomResourceDefinitionCondition();
    public KubeSchemaFluent.CustomResourceDefinitionConditionNested<A> editOrNewCustomResourceDefinitionCondition();
    public KubeSchemaFluent.CustomResourceDefinitionConditionNested<A> editOrNewCustomResourceDefinitionConditionLike(CustomResourceDefinitionCondition item);
    public A withNewCustomResourceDefinitionCondition(String lastTransitionTime,String message,String reason,String status,String type);
    
/**
 * This method has been deprecated, please use method buildCustomResourceDefinitionList instead.
 */
@Deprecated public CustomResourceDefinitionList getCustomResourceDefinitionList();
    public CustomResourceDefinitionList buildCustomResourceDefinitionList();
    public A withCustomResourceDefinitionList(CustomResourceDefinitionList customResourceDefinitionList);
    public Boolean hasCustomResourceDefinitionList();
    public KubeSchemaFluent.CustomResourceDefinitionListNested<A> withNewCustomResourceDefinitionList();
    public KubeSchemaFluent.CustomResourceDefinitionListNested<A> withNewCustomResourceDefinitionListLike(CustomResourceDefinitionList item);
    public KubeSchemaFluent.CustomResourceDefinitionListNested<A> editCustomResourceDefinitionList();
    public KubeSchemaFluent.CustomResourceDefinitionListNested<A> editOrNewCustomResourceDefinitionList();
    public KubeSchemaFluent.CustomResourceDefinitionListNested<A> editOrNewCustomResourceDefinitionListLike(CustomResourceDefinitionList item);
    
/**
 * This method has been deprecated, please use method buildCustomResourceDefinitionNames instead.
 */
@Deprecated public CustomResourceDefinitionNames getCustomResourceDefinitionNames();
    public CustomResourceDefinitionNames buildCustomResourceDefinitionNames();
    public A withCustomResourceDefinitionNames(CustomResourceDefinitionNames customResourceDefinitionNames);
    public Boolean hasCustomResourceDefinitionNames();
    public KubeSchemaFluent.CustomResourceDefinitionNamesNested<A> withNewCustomResourceDefinitionNames();
    public KubeSchemaFluent.CustomResourceDefinitionNamesNested<A> withNewCustomResourceDefinitionNamesLike(CustomResourceDefinitionNames item);
    public KubeSchemaFluent.CustomResourceDefinitionNamesNested<A> editCustomResourceDefinitionNames();
    public KubeSchemaFluent.CustomResourceDefinitionNamesNested<A> editOrNewCustomResourceDefinitionNames();
    public KubeSchemaFluent.CustomResourceDefinitionNamesNested<A> editOrNewCustomResourceDefinitionNamesLike(CustomResourceDefinitionNames item);
    
/**
 * This method has been deprecated, please use method buildCustomResourceDefinitionSpec instead.
 */
@Deprecated public CustomResourceDefinitionSpec getCustomResourceDefinitionSpec();
    public CustomResourceDefinitionSpec buildCustomResourceDefinitionSpec();
    public A withCustomResourceDefinitionSpec(CustomResourceDefinitionSpec customResourceDefinitionSpec);
    public Boolean hasCustomResourceDefinitionSpec();
    public KubeSchemaFluent.CustomResourceDefinitionSpecNested<A> withNewCustomResourceDefinitionSpec();
    public KubeSchemaFluent.CustomResourceDefinitionSpecNested<A> withNewCustomResourceDefinitionSpecLike(CustomResourceDefinitionSpec item);
    public KubeSchemaFluent.CustomResourceDefinitionSpecNested<A> editCustomResourceDefinitionSpec();
    public KubeSchemaFluent.CustomResourceDefinitionSpecNested<A> editOrNewCustomResourceDefinitionSpec();
    public KubeSchemaFluent.CustomResourceDefinitionSpecNested<A> editOrNewCustomResourceDefinitionSpecLike(CustomResourceDefinitionSpec item);
    
/**
 * This method has been deprecated, please use method buildCustomResourceDefinitionStatus instead.
 */
@Deprecated public CustomResourceDefinitionStatus getCustomResourceDefinitionStatus();
    public CustomResourceDefinitionStatus buildCustomResourceDefinitionStatus();
    public A withCustomResourceDefinitionStatus(CustomResourceDefinitionStatus customResourceDefinitionStatus);
    public Boolean hasCustomResourceDefinitionStatus();
    public KubeSchemaFluent.CustomResourceDefinitionStatusNested<A> withNewCustomResourceDefinitionStatus();
    public KubeSchemaFluent.CustomResourceDefinitionStatusNested<A> withNewCustomResourceDefinitionStatusLike(CustomResourceDefinitionStatus item);
    public KubeSchemaFluent.CustomResourceDefinitionStatusNested<A> editCustomResourceDefinitionStatus();
    public KubeSchemaFluent.CustomResourceDefinitionStatusNested<A> editOrNewCustomResourceDefinitionStatus();
    public KubeSchemaFluent.CustomResourceDefinitionStatusNested<A> editOrNewCustomResourceDefinitionStatusLike(CustomResourceDefinitionStatus item);
    
/**
 * This method has been deprecated, please use method buildDaemonSet instead.
 */
@Deprecated public DaemonSet getDaemonSet();
    public DaemonSet buildDaemonSet();
    public A withDaemonSet(DaemonSet daemonSet);
    public Boolean hasDaemonSet();
    public KubeSchemaFluent.DaemonSetNested<A> withNewDaemonSet();
    public KubeSchemaFluent.DaemonSetNested<A> withNewDaemonSetLike(DaemonSet item);
    public KubeSchemaFluent.DaemonSetNested<A> editDaemonSet();
    public KubeSchemaFluent.DaemonSetNested<A> editOrNewDaemonSet();
    public KubeSchemaFluent.DaemonSetNested<A> editOrNewDaemonSetLike(DaemonSet item);
    
/**
 * This method has been deprecated, please use method buildDaemonSetList instead.
 */
@Deprecated public DaemonSetList getDaemonSetList();
    public DaemonSetList buildDaemonSetList();
    public A withDaemonSetList(DaemonSetList daemonSetList);
    public Boolean hasDaemonSetList();
    public KubeSchemaFluent.DaemonSetListNested<A> withNewDaemonSetList();
    public KubeSchemaFluent.DaemonSetListNested<A> withNewDaemonSetListLike(DaemonSetList item);
    public KubeSchemaFluent.DaemonSetListNested<A> editDaemonSetList();
    public KubeSchemaFluent.DaemonSetListNested<A> editOrNewDaemonSetList();
    public KubeSchemaFluent.DaemonSetListNested<A> editOrNewDaemonSetListLike(DaemonSetList item);
    
/**
 * This method has been deprecated, please use method buildDeleteOptions instead.
 */
@Deprecated public DeleteOptions getDeleteOptions();
    public DeleteOptions buildDeleteOptions();
    public A withDeleteOptions(DeleteOptions deleteOptions);
    public Boolean hasDeleteOptions();
    public KubeSchemaFluent.DeleteOptionsNested<A> withNewDeleteOptions();
    public KubeSchemaFluent.DeleteOptionsNested<A> withNewDeleteOptionsLike(DeleteOptions item);
    public KubeSchemaFluent.DeleteOptionsNested<A> editDeleteOptions();
    public KubeSchemaFluent.DeleteOptionsNested<A> editOrNewDeleteOptions();
    public KubeSchemaFluent.DeleteOptionsNested<A> editOrNewDeleteOptionsLike(DeleteOptions item);
    
/**
 * This method has been deprecated, please use method buildDeployment instead.
 */
@Deprecated public Deployment getDeployment();
    public Deployment buildDeployment();
    public A withDeployment(Deployment deployment);
    public Boolean hasDeployment();
    public KubeSchemaFluent.DeploymentNested<A> withNewDeployment();
    public KubeSchemaFluent.DeploymentNested<A> withNewDeploymentLike(Deployment item);
    public KubeSchemaFluent.DeploymentNested<A> editDeployment();
    public KubeSchemaFluent.DeploymentNested<A> editOrNewDeployment();
    public KubeSchemaFluent.DeploymentNested<A> editOrNewDeploymentLike(Deployment item);
    
/**
 * This method has been deprecated, please use method buildDeploymentConfig instead.
 */
@Deprecated public DeploymentConfig getDeploymentConfig();
    public DeploymentConfig buildDeploymentConfig();
    public A withDeploymentConfig(DeploymentConfig deploymentConfig);
    public Boolean hasDeploymentConfig();
    public KubeSchemaFluent.DeploymentConfigNested<A> withNewDeploymentConfig();
    public KubeSchemaFluent.DeploymentConfigNested<A> withNewDeploymentConfigLike(DeploymentConfig item);
    public KubeSchemaFluent.DeploymentConfigNested<A> editDeploymentConfig();
    public KubeSchemaFluent.DeploymentConfigNested<A> editOrNewDeploymentConfig();
    public KubeSchemaFluent.DeploymentConfigNested<A> editOrNewDeploymentConfigLike(DeploymentConfig item);
    
/**
 * This method has been deprecated, please use method buildDeploymentConfigList instead.
 */
@Deprecated public DeploymentConfigList getDeploymentConfigList();
    public DeploymentConfigList buildDeploymentConfigList();
    public A withDeploymentConfigList(DeploymentConfigList deploymentConfigList);
    public Boolean hasDeploymentConfigList();
    public KubeSchemaFluent.DeploymentConfigListNested<A> withNewDeploymentConfigList();
    public KubeSchemaFluent.DeploymentConfigListNested<A> withNewDeploymentConfigListLike(DeploymentConfigList item);
    public KubeSchemaFluent.DeploymentConfigListNested<A> editDeploymentConfigList();
    public KubeSchemaFluent.DeploymentConfigListNested<A> editOrNewDeploymentConfigList();
    public KubeSchemaFluent.DeploymentConfigListNested<A> editOrNewDeploymentConfigListLike(DeploymentConfigList item);
    
/**
 * This method has been deprecated, please use method buildDeploymentList instead.
 */
@Deprecated public DeploymentList getDeploymentList();
    public DeploymentList buildDeploymentList();
    public A withDeploymentList(DeploymentList deploymentList);
    public Boolean hasDeploymentList();
    public KubeSchemaFluent.DeploymentListNested<A> withNewDeploymentList();
    public KubeSchemaFluent.DeploymentListNested<A> withNewDeploymentListLike(DeploymentList item);
    public KubeSchemaFluent.DeploymentListNested<A> editDeploymentList();
    public KubeSchemaFluent.DeploymentListNested<A> editOrNewDeploymentList();
    public KubeSchemaFluent.DeploymentListNested<A> editOrNewDeploymentListLike(DeploymentList item);
    
/**
 * This method has been deprecated, please use method buildDeploymentRollback instead.
 */
@Deprecated public DeploymentRollback getDeploymentRollback();
    public DeploymentRollback buildDeploymentRollback();
    public A withDeploymentRollback(DeploymentRollback deploymentRollback);
    public Boolean hasDeploymentRollback();
    public KubeSchemaFluent.DeploymentRollbackNested<A> withNewDeploymentRollback();
    public KubeSchemaFluent.DeploymentRollbackNested<A> withNewDeploymentRollbackLike(DeploymentRollback item);
    public KubeSchemaFluent.DeploymentRollbackNested<A> editDeploymentRollback();
    public KubeSchemaFluent.DeploymentRollbackNested<A> editOrNewDeploymentRollback();
    public KubeSchemaFluent.DeploymentRollbackNested<A> editOrNewDeploymentRollbackLike(DeploymentRollback item);
    
/**
 * This method has been deprecated, please use method buildEndpoints instead.
 */
@Deprecated public Endpoints getEndpoints();
    public Endpoints buildEndpoints();
    public A withEndpoints(Endpoints endpoints);
    public Boolean hasEndpoints();
    public KubeSchemaFluent.EndpointsNested<A> withNewEndpoints();
    public KubeSchemaFluent.EndpointsNested<A> withNewEndpointsLike(Endpoints item);
    public KubeSchemaFluent.EndpointsNested<A> editEndpoints();
    public KubeSchemaFluent.EndpointsNested<A> editOrNewEndpoints();
    public KubeSchemaFluent.EndpointsNested<A> editOrNewEndpointsLike(Endpoints item);
    
/**
 * This method has been deprecated, please use method buildEndpointsList instead.
 */
@Deprecated public EndpointsList getEndpointsList();
    public EndpointsList buildEndpointsList();
    public A withEndpointsList(EndpointsList endpointsList);
    public Boolean hasEndpointsList();
    public KubeSchemaFluent.EndpointsListNested<A> withNewEndpointsList();
    public KubeSchemaFluent.EndpointsListNested<A> withNewEndpointsListLike(EndpointsList item);
    public KubeSchemaFluent.EndpointsListNested<A> editEndpointsList();
    public KubeSchemaFluent.EndpointsListNested<A> editOrNewEndpointsList();
    public KubeSchemaFluent.EndpointsListNested<A> editOrNewEndpointsListLike(EndpointsList item);
    
/**
 * This method has been deprecated, please use method buildEnvVar instead.
 */
@Deprecated public EnvVar getEnvVar();
    public EnvVar buildEnvVar();
    public A withEnvVar(EnvVar envVar);
    public Boolean hasEnvVar();
    public KubeSchemaFluent.EnvVarNested<A> withNewEnvVar();
    public KubeSchemaFluent.EnvVarNested<A> withNewEnvVarLike(EnvVar item);
    public KubeSchemaFluent.EnvVarNested<A> editEnvVar();
    public KubeSchemaFluent.EnvVarNested<A> editOrNewEnvVar();
    public KubeSchemaFluent.EnvVarNested<A> editOrNewEnvVarLike(EnvVar item);
    
/**
 * This method has been deprecated, please use method buildEventList instead.
 */
@Deprecated public EventList getEventList();
    public EventList buildEventList();
    public A withEventList(EventList eventList);
    public Boolean hasEventList();
    public KubeSchemaFluent.EventListNested<A> withNewEventList();
    public KubeSchemaFluent.EventListNested<A> withNewEventListLike(EventList item);
    public KubeSchemaFluent.EventListNested<A> editEventList();
    public KubeSchemaFluent.EventListNested<A> editOrNewEventList();
    public KubeSchemaFluent.EventListNested<A> editOrNewEventListLike(EventList item);
    
/**
 * This method has been deprecated, please use method buildGroup instead.
 */
@Deprecated public Group getGroup();
    public Group buildGroup();
    public A withGroup(Group group);
    public Boolean hasGroup();
    public KubeSchemaFluent.GroupNested<A> withNewGroup();
    public KubeSchemaFluent.GroupNested<A> withNewGroupLike(Group item);
    public KubeSchemaFluent.GroupNested<A> editGroup();
    public KubeSchemaFluent.GroupNested<A> editOrNewGroup();
    public KubeSchemaFluent.GroupNested<A> editOrNewGroupLike(Group item);
    
/**
 * This method has been deprecated, please use method buildGroupList instead.
 */
@Deprecated public GroupList getGroupList();
    public GroupList buildGroupList();
    public A withGroupList(GroupList groupList);
    public Boolean hasGroupList();
    public KubeSchemaFluent.GroupListNested<A> withNewGroupList();
    public KubeSchemaFluent.GroupListNested<A> withNewGroupListLike(GroupList item);
    public KubeSchemaFluent.GroupListNested<A> editGroupList();
    public KubeSchemaFluent.GroupListNested<A> editOrNewGroupList();
    public KubeSchemaFluent.GroupListNested<A> editOrNewGroupListLike(GroupList item);
    
/**
 * This method has been deprecated, please use method buildHorizontalPodAutoscaler instead.
 */
@Deprecated public HorizontalPodAutoscaler getHorizontalPodAutoscaler();
    public HorizontalPodAutoscaler buildHorizontalPodAutoscaler();
    public A withHorizontalPodAutoscaler(HorizontalPodAutoscaler horizontalPodAutoscaler);
    public Boolean hasHorizontalPodAutoscaler();
    public KubeSchemaFluent.HorizontalPodAutoscalerNested<A> withNewHorizontalPodAutoscaler();
    public KubeSchemaFluent.HorizontalPodAutoscalerNested<A> withNewHorizontalPodAutoscalerLike(HorizontalPodAutoscaler item);
    public KubeSchemaFluent.HorizontalPodAutoscalerNested<A> editHorizontalPodAutoscaler();
    public KubeSchemaFluent.HorizontalPodAutoscalerNested<A> editOrNewHorizontalPodAutoscaler();
    public KubeSchemaFluent.HorizontalPodAutoscalerNested<A> editOrNewHorizontalPodAutoscalerLike(HorizontalPodAutoscaler item);
    
/**
 * This method has been deprecated, please use method buildHorizontalPodAutoscalerList instead.
 */
@Deprecated public HorizontalPodAutoscalerList getHorizontalPodAutoscalerList();
    public HorizontalPodAutoscalerList buildHorizontalPodAutoscalerList();
    public A withHorizontalPodAutoscalerList(HorizontalPodAutoscalerList horizontalPodAutoscalerList);
    public Boolean hasHorizontalPodAutoscalerList();
    public KubeSchemaFluent.HorizontalPodAutoscalerListNested<A> withNewHorizontalPodAutoscalerList();
    public KubeSchemaFluent.HorizontalPodAutoscalerListNested<A> withNewHorizontalPodAutoscalerListLike(HorizontalPodAutoscalerList item);
    public KubeSchemaFluent.HorizontalPodAutoscalerListNested<A> editHorizontalPodAutoscalerList();
    public KubeSchemaFluent.HorizontalPodAutoscalerListNested<A> editOrNewHorizontalPodAutoscalerList();
    public KubeSchemaFluent.HorizontalPodAutoscalerListNested<A> editOrNewHorizontalPodAutoscalerListLike(HorizontalPodAutoscalerList item);
    
/**
 * This method has been deprecated, please use method buildIdentity instead.
 */
@Deprecated public Identity getIdentity();
    public Identity buildIdentity();
    public A withIdentity(Identity identity);
    public Boolean hasIdentity();
    public KubeSchemaFluent.IdentityNested<A> withNewIdentity();
    public KubeSchemaFluent.IdentityNested<A> withNewIdentityLike(Identity item);
    public KubeSchemaFluent.IdentityNested<A> editIdentity();
    public KubeSchemaFluent.IdentityNested<A> editOrNewIdentity();
    public KubeSchemaFluent.IdentityNested<A> editOrNewIdentityLike(Identity item);
    
/**
 * This method has been deprecated, please use method buildIdentityList instead.
 */
@Deprecated public IdentityList getIdentityList();
    public IdentityList buildIdentityList();
    public A withIdentityList(IdentityList identityList);
    public Boolean hasIdentityList();
    public KubeSchemaFluent.IdentityListNested<A> withNewIdentityList();
    public KubeSchemaFluent.IdentityListNested<A> withNewIdentityListLike(IdentityList item);
    public KubeSchemaFluent.IdentityListNested<A> editIdentityList();
    public KubeSchemaFluent.IdentityListNested<A> editOrNewIdentityList();
    public KubeSchemaFluent.IdentityListNested<A> editOrNewIdentityListLike(IdentityList item);
    
/**
 * This method has been deprecated, please use method buildImageList instead.
 */
@Deprecated public ImageList getImageList();
    public ImageList buildImageList();
    public A withImageList(ImageList imageList);
    public Boolean hasImageList();
    public KubeSchemaFluent.ImageListNested<A> withNewImageList();
    public KubeSchemaFluent.ImageListNested<A> withNewImageListLike(ImageList item);
    public KubeSchemaFluent.ImageListNested<A> editImageList();
    public KubeSchemaFluent.ImageListNested<A> editOrNewImageList();
    public KubeSchemaFluent.ImageListNested<A> editOrNewImageListLike(ImageList item);
    
/**
 * This method has been deprecated, please use method buildImageStreamList instead.
 */
@Deprecated public ImageStreamList getImageStreamList();
    public ImageStreamList buildImageStreamList();
    public A withImageStreamList(ImageStreamList imageStreamList);
    public Boolean hasImageStreamList();
    public KubeSchemaFluent.ImageStreamListNested<A> withNewImageStreamList();
    public KubeSchemaFluent.ImageStreamListNested<A> withNewImageStreamListLike(ImageStreamList item);
    public KubeSchemaFluent.ImageStreamListNested<A> editImageStreamList();
    public KubeSchemaFluent.ImageStreamListNested<A> editOrNewImageStreamList();
    public KubeSchemaFluent.ImageStreamListNested<A> editOrNewImageStreamListLike(ImageStreamList item);
    
/**
 * This method has been deprecated, please use method buildImageStreamTagList instead.
 */
@Deprecated public ImageStreamTagList getImageStreamTagList();
    public ImageStreamTagList buildImageStreamTagList();
    public A withImageStreamTagList(ImageStreamTagList imageStreamTagList);
    public Boolean hasImageStreamTagList();
    public KubeSchemaFluent.ImageStreamTagListNested<A> withNewImageStreamTagList();
    public KubeSchemaFluent.ImageStreamTagListNested<A> withNewImageStreamTagListLike(ImageStreamTagList item);
    public KubeSchemaFluent.ImageStreamTagListNested<A> editImageStreamTagList();
    public KubeSchemaFluent.ImageStreamTagListNested<A> editOrNewImageStreamTagList();
    public KubeSchemaFluent.ImageStreamTagListNested<A> editOrNewImageStreamTagListLike(ImageStreamTagList item);
    
/**
 * This method has been deprecated, please use method buildInfo instead.
 */
@Deprecated public Info getInfo();
    public Info buildInfo();
    public A withInfo(Info info);
    public Boolean hasInfo();
    public KubeSchemaFluent.InfoNested<A> withNewInfo();
    public KubeSchemaFluent.InfoNested<A> withNewInfoLike(Info item);
    public KubeSchemaFluent.InfoNested<A> editInfo();
    public KubeSchemaFluent.InfoNested<A> editOrNewInfo();
    public KubeSchemaFluent.InfoNested<A> editOrNewInfoLike(Info item);
    
/**
 * This method has been deprecated, please use method buildIngress instead.
 */
@Deprecated public Ingress getIngress();
    public Ingress buildIngress();
    public A withIngress(Ingress ingress);
    public Boolean hasIngress();
    public KubeSchemaFluent.IngressNested<A> withNewIngress();
    public KubeSchemaFluent.IngressNested<A> withNewIngressLike(Ingress item);
    public KubeSchemaFluent.IngressNested<A> editIngress();
    public KubeSchemaFluent.IngressNested<A> editOrNewIngress();
    public KubeSchemaFluent.IngressNested<A> editOrNewIngressLike(Ingress item);
    
/**
 * This method has been deprecated, please use method buildIngressList instead.
 */
@Deprecated public IngressList getIngressList();
    public IngressList buildIngressList();
    public A withIngressList(IngressList ingressList);
    public Boolean hasIngressList();
    public KubeSchemaFluent.IngressListNested<A> withNewIngressList();
    public KubeSchemaFluent.IngressListNested<A> withNewIngressListLike(IngressList item);
    public KubeSchemaFluent.IngressListNested<A> editIngressList();
    public KubeSchemaFluent.IngressListNested<A> editOrNewIngressList();
    public KubeSchemaFluent.IngressListNested<A> editOrNewIngressListLike(IngressList item);
    
/**
 * This method has been deprecated, please use method buildInitializer instead.
 */
@Deprecated public Initializer getInitializer();
    public Initializer buildInitializer();
    public A withInitializer(Initializer initializer);
    public Boolean hasInitializer();
    public KubeSchemaFluent.InitializerNested<A> withNewInitializer();
    public KubeSchemaFluent.InitializerNested<A> withNewInitializerLike(Initializer item);
    public KubeSchemaFluent.InitializerNested<A> editInitializer();
    public KubeSchemaFluent.InitializerNested<A> editOrNewInitializer();
    public KubeSchemaFluent.InitializerNested<A> editOrNewInitializerLike(Initializer item);
    public A withNewInitializer(String name);
    
/**
 * This method has been deprecated, please use method buildInitializers instead.
 */
@Deprecated public Initializers getInitializers();
    public Initializers buildInitializers();
    public A withInitializers(Initializers initializers);
    public Boolean hasInitializers();
    public KubeSchemaFluent.InitializersNested<A> withNewInitializers();
    public KubeSchemaFluent.InitializersNested<A> withNewInitializersLike(Initializers item);
    public KubeSchemaFluent.InitializersNested<A> editInitializers();
    public KubeSchemaFluent.InitializersNested<A> editOrNewInitializers();
    public KubeSchemaFluent.InitializersNested<A> editOrNewInitializersLike(Initializers item);
    
/**
 * This method has been deprecated, please use method buildJob instead.
 */
@Deprecated public Job getJob();
    public Job buildJob();
    public A withJob(Job job);
    public Boolean hasJob();
    public KubeSchemaFluent.JobNested<A> withNewJob();
    public KubeSchemaFluent.JobNested<A> withNewJobLike(Job item);
    public KubeSchemaFluent.JobNested<A> editJob();
    public KubeSchemaFluent.JobNested<A> editOrNewJob();
    public KubeSchemaFluent.JobNested<A> editOrNewJobLike(Job item);
    
/**
 * This method has been deprecated, please use method buildJobList instead.
 */
@Deprecated public JobList getJobList();
    public JobList buildJobList();
    public A withJobList(JobList jobList);
    public Boolean hasJobList();
    public KubeSchemaFluent.JobListNested<A> withNewJobList();
    public KubeSchemaFluent.JobListNested<A> withNewJobListLike(JobList item);
    public KubeSchemaFluent.JobListNested<A> editJobList();
    public KubeSchemaFluent.JobListNested<A> editOrNewJobList();
    public KubeSchemaFluent.JobListNested<A> editOrNewJobListLike(JobList item);
    
/**
 * This method has been deprecated, please use method buildK8sLocalSubjectAccessReview instead.
 */
@Deprecated public LocalSubjectAccessReview getK8sLocalSubjectAccessReview();
    public LocalSubjectAccessReview buildK8sLocalSubjectAccessReview();
    public A withK8sLocalSubjectAccessReview(LocalSubjectAccessReview k8sLocalSubjectAccessReview);
    public Boolean hasK8sLocalSubjectAccessReview();
    public KubeSchemaFluent.K8sLocalSubjectAccessReviewNested<A> withNewK8sLocalSubjectAccessReview();
    public KubeSchemaFluent.K8sLocalSubjectAccessReviewNested<A> withNewK8sLocalSubjectAccessReviewLike(LocalSubjectAccessReview item);
    public KubeSchemaFluent.K8sLocalSubjectAccessReviewNested<A> editK8sLocalSubjectAccessReview();
    public KubeSchemaFluent.K8sLocalSubjectAccessReviewNested<A> editOrNewK8sLocalSubjectAccessReview();
    public KubeSchemaFluent.K8sLocalSubjectAccessReviewNested<A> editOrNewK8sLocalSubjectAccessReviewLike(LocalSubjectAccessReview item);
    
/**
 * This method has been deprecated, please use method buildK8sSubjectAccessReview instead.
 */
@Deprecated public SubjectAccessReview getK8sSubjectAccessReview();
    public SubjectAccessReview buildK8sSubjectAccessReview();
    public A withK8sSubjectAccessReview(SubjectAccessReview k8sSubjectAccessReview);
    public Boolean hasK8sSubjectAccessReview();
    public KubeSchemaFluent.K8sSubjectAccessReviewNested<A> withNewK8sSubjectAccessReview();
    public KubeSchemaFluent.K8sSubjectAccessReviewNested<A> withNewK8sSubjectAccessReviewLike(SubjectAccessReview item);
    public KubeSchemaFluent.K8sSubjectAccessReviewNested<A> editK8sSubjectAccessReview();
    public KubeSchemaFluent.K8sSubjectAccessReviewNested<A> editOrNewK8sSubjectAccessReview();
    public KubeSchemaFluent.K8sSubjectAccessReviewNested<A> editOrNewK8sSubjectAccessReviewLike(SubjectAccessReview item);
    
/**
 * This method has been deprecated, please use method buildLimitRangeList instead.
 */
@Deprecated public LimitRangeList getLimitRangeList();
    public LimitRangeList buildLimitRangeList();
    public A withLimitRangeList(LimitRangeList limitRangeList);
    public Boolean hasLimitRangeList();
    public KubeSchemaFluent.LimitRangeListNested<A> withNewLimitRangeList();
    public KubeSchemaFluent.LimitRangeListNested<A> withNewLimitRangeListLike(LimitRangeList item);
    public KubeSchemaFluent.LimitRangeListNested<A> editLimitRangeList();
    public KubeSchemaFluent.LimitRangeListNested<A> editOrNewLimitRangeList();
    public KubeSchemaFluent.LimitRangeListNested<A> editOrNewLimitRangeListLike(LimitRangeList item);
    
/**
 * This method has been deprecated, please use method buildListMeta instead.
 */
@Deprecated public ListMeta getListMeta();
    public ListMeta buildListMeta();
    public A withListMeta(ListMeta listMeta);
    public Boolean hasListMeta();
    public KubeSchemaFluent.ListMetaNested<A> withNewListMeta();
    public KubeSchemaFluent.ListMetaNested<A> withNewListMetaLike(ListMeta item);
    public KubeSchemaFluent.ListMetaNested<A> editListMeta();
    public KubeSchemaFluent.ListMetaNested<A> editOrNewListMeta();
    public KubeSchemaFluent.ListMetaNested<A> editOrNewListMetaLike(ListMeta item);
    public A withNewListMeta(String resourceVersion,String selfLink);
    
/**
 * This method has been deprecated, please use method buildLocalSubjectAccessReview instead.
 */
@Deprecated public io.fabric8.openshift.api.model.LocalSubjectAccessReview getLocalSubjectAccessReview();
    public io.fabric8.openshift.api.model.LocalSubjectAccessReview buildLocalSubjectAccessReview();
    public A withLocalSubjectAccessReview(io.fabric8.openshift.api.model.LocalSubjectAccessReview localSubjectAccessReview);
    public Boolean hasLocalSubjectAccessReview();
    public KubeSchemaFluent.ModelLocalSubjectAccessReviewNested<A> withNewModelLocalSubjectAccessReview();
    public KubeSchemaFluent.ModelLocalSubjectAccessReviewNested<A> withNewLocalSubjectAccessReviewLike(io.fabric8.openshift.api.model.LocalSubjectAccessReview item);
    public KubeSchemaFluent.ModelLocalSubjectAccessReviewNested<A> editModelLocalSubjectAccessReview();
    public KubeSchemaFluent.ModelLocalSubjectAccessReviewNested<A> editOrNewLocalSubjectAccessReview();
    public KubeSchemaFluent.ModelLocalSubjectAccessReviewNested<A> editOrNewLocalSubjectAccessReviewLike(io.fabric8.openshift.api.model.LocalSubjectAccessReview item);
    
/**
 * This method has been deprecated, please use method buildNamespace instead.
 */
@Deprecated public Namespace getNamespace();
    public Namespace buildNamespace();
    public A withNamespace(Namespace namespace);
    public Boolean hasNamespace();
    public KubeSchemaFluent.NamespaceNested<A> withNewNamespace();
    public KubeSchemaFluent.NamespaceNested<A> withNewNamespaceLike(Namespace item);
    public KubeSchemaFluent.NamespaceNested<A> editNamespace();
    public KubeSchemaFluent.NamespaceNested<A> editOrNewNamespace();
    public KubeSchemaFluent.NamespaceNested<A> editOrNewNamespaceLike(Namespace item);
    
/**
 * This method has been deprecated, please use method buildNamespaceList instead.
 */
@Deprecated public NamespaceList getNamespaceList();
    public NamespaceList buildNamespaceList();
    public A withNamespaceList(NamespaceList namespaceList);
    public Boolean hasNamespaceList();
    public KubeSchemaFluent.NamespaceListNested<A> withNewNamespaceList();
    public KubeSchemaFluent.NamespaceListNested<A> withNewNamespaceListLike(NamespaceList item);
    public KubeSchemaFluent.NamespaceListNested<A> editNamespaceList();
    public KubeSchemaFluent.NamespaceListNested<A> editOrNewNamespaceList();
    public KubeSchemaFluent.NamespaceListNested<A> editOrNewNamespaceListLike(NamespaceList item);
    
/**
 * This method has been deprecated, please use method buildNetworkPolicy instead.
 */
@Deprecated public NetworkPolicy getNetworkPolicy();
    public NetworkPolicy buildNetworkPolicy();
    public A withNetworkPolicy(NetworkPolicy networkPolicy);
    public Boolean hasNetworkPolicy();
    public KubeSchemaFluent.NetworkPolicyNested<A> withNewNetworkPolicy();
    public KubeSchemaFluent.NetworkPolicyNested<A> withNewNetworkPolicyLike(NetworkPolicy item);
    public KubeSchemaFluent.NetworkPolicyNested<A> editNetworkPolicy();
    public KubeSchemaFluent.NetworkPolicyNested<A> editOrNewNetworkPolicy();
    public KubeSchemaFluent.NetworkPolicyNested<A> editOrNewNetworkPolicyLike(NetworkPolicy item);
    
/**
 * This method has been deprecated, please use method buildNetworkPolicyList instead.
 */
@Deprecated public NetworkPolicyList getNetworkPolicyList();
    public NetworkPolicyList buildNetworkPolicyList();
    public A withNetworkPolicyList(NetworkPolicyList networkPolicyList);
    public Boolean hasNetworkPolicyList();
    public KubeSchemaFluent.NetworkPolicyListNested<A> withNewNetworkPolicyList();
    public KubeSchemaFluent.NetworkPolicyListNested<A> withNewNetworkPolicyListLike(NetworkPolicyList item);
    public KubeSchemaFluent.NetworkPolicyListNested<A> editNetworkPolicyList();
    public KubeSchemaFluent.NetworkPolicyListNested<A> editOrNewNetworkPolicyList();
    public KubeSchemaFluent.NetworkPolicyListNested<A> editOrNewNetworkPolicyListLike(NetworkPolicyList item);
    
/**
 * This method has been deprecated, please use method buildNode instead.
 */
@Deprecated public Node getNode();
    public Node buildNode();
    public A withNode(Node node);
    public Boolean hasNode();
    public KubeSchemaFluent.NodeNested<A> withNewNode();
    public KubeSchemaFluent.NodeNested<A> withNewNodeLike(Node item);
    public KubeSchemaFluent.NodeNested<A> editNode();
    public KubeSchemaFluent.NodeNested<A> editOrNewNode();
    public KubeSchemaFluent.NodeNested<A> editOrNewNodeLike(Node item);
    
/**
 * This method has been deprecated, please use method buildNodeList instead.
 */
@Deprecated public NodeList getNodeList();
    public NodeList buildNodeList();
    public A withNodeList(NodeList nodeList);
    public Boolean hasNodeList();
    public KubeSchemaFluent.NodeListNested<A> withNewNodeList();
    public KubeSchemaFluent.NodeListNested<A> withNewNodeListLike(NodeList item);
    public KubeSchemaFluent.NodeListNested<A> editNodeList();
    public KubeSchemaFluent.NodeListNested<A> editOrNewNodeList();
    public KubeSchemaFluent.NodeListNested<A> editOrNewNodeListLike(NodeList item);
    
/**
 * This method has been deprecated, please use method buildOAuthAccessToken instead.
 */
@Deprecated public OAuthAccessToken getOAuthAccessToken();
    public OAuthAccessToken buildOAuthAccessToken();
    public A withOAuthAccessToken(OAuthAccessToken oAuthAccessToken);
    public Boolean hasOAuthAccessToken();
    public KubeSchemaFluent.OAuthAccessTokenNested<A> withNewOAuthAccessToken();
    public KubeSchemaFluent.OAuthAccessTokenNested<A> withNewOAuthAccessTokenLike(OAuthAccessToken item);
    public KubeSchemaFluent.OAuthAccessTokenNested<A> editOAuthAccessToken();
    public KubeSchemaFluent.OAuthAccessTokenNested<A> editOrNewOAuthAccessToken();
    public KubeSchemaFluent.OAuthAccessTokenNested<A> editOrNewOAuthAccessTokenLike(OAuthAccessToken item);
    
/**
 * This method has been deprecated, please use method buildOAuthAccessTokenList instead.
 */
@Deprecated public OAuthAccessTokenList getOAuthAccessTokenList();
    public OAuthAccessTokenList buildOAuthAccessTokenList();
    public A withOAuthAccessTokenList(OAuthAccessTokenList oAuthAccessTokenList);
    public Boolean hasOAuthAccessTokenList();
    public KubeSchemaFluent.OAuthAccessTokenListNested<A> withNewOAuthAccessTokenList();
    public KubeSchemaFluent.OAuthAccessTokenListNested<A> withNewOAuthAccessTokenListLike(OAuthAccessTokenList item);
    public KubeSchemaFluent.OAuthAccessTokenListNested<A> editOAuthAccessTokenList();
    public KubeSchemaFluent.OAuthAccessTokenListNested<A> editOrNewOAuthAccessTokenList();
    public KubeSchemaFluent.OAuthAccessTokenListNested<A> editOrNewOAuthAccessTokenListLike(OAuthAccessTokenList item);
    
/**
 * This method has been deprecated, please use method buildOAuthAuthorizeToken instead.
 */
@Deprecated public OAuthAuthorizeToken getOAuthAuthorizeToken();
    public OAuthAuthorizeToken buildOAuthAuthorizeToken();
    public A withOAuthAuthorizeToken(OAuthAuthorizeToken oAuthAuthorizeToken);
    public Boolean hasOAuthAuthorizeToken();
    public KubeSchemaFluent.OAuthAuthorizeTokenNested<A> withNewOAuthAuthorizeToken();
    public KubeSchemaFluent.OAuthAuthorizeTokenNested<A> withNewOAuthAuthorizeTokenLike(OAuthAuthorizeToken item);
    public KubeSchemaFluent.OAuthAuthorizeTokenNested<A> editOAuthAuthorizeToken();
    public KubeSchemaFluent.OAuthAuthorizeTokenNested<A> editOrNewOAuthAuthorizeToken();
    public KubeSchemaFluent.OAuthAuthorizeTokenNested<A> editOrNewOAuthAuthorizeTokenLike(OAuthAuthorizeToken item);
    
/**
 * This method has been deprecated, please use method buildOAuthAuthorizeTokenList instead.
 */
@Deprecated public OAuthAuthorizeTokenList getOAuthAuthorizeTokenList();
    public OAuthAuthorizeTokenList buildOAuthAuthorizeTokenList();
    public A withOAuthAuthorizeTokenList(OAuthAuthorizeTokenList oAuthAuthorizeTokenList);
    public Boolean hasOAuthAuthorizeTokenList();
    public KubeSchemaFluent.OAuthAuthorizeTokenListNested<A> withNewOAuthAuthorizeTokenList();
    public KubeSchemaFluent.OAuthAuthorizeTokenListNested<A> withNewOAuthAuthorizeTokenListLike(OAuthAuthorizeTokenList item);
    public KubeSchemaFluent.OAuthAuthorizeTokenListNested<A> editOAuthAuthorizeTokenList();
    public KubeSchemaFluent.OAuthAuthorizeTokenListNested<A> editOrNewOAuthAuthorizeTokenList();
    public KubeSchemaFluent.OAuthAuthorizeTokenListNested<A> editOrNewOAuthAuthorizeTokenListLike(OAuthAuthorizeTokenList item);
    
/**
 * This method has been deprecated, please use method buildOAuthClient instead.
 */
@Deprecated public OAuthClient getOAuthClient();
    public OAuthClient buildOAuthClient();
    public A withOAuthClient(OAuthClient oAuthClient);
    public Boolean hasOAuthClient();
    public KubeSchemaFluent.OAuthClientNested<A> withNewOAuthClient();
    public KubeSchemaFluent.OAuthClientNested<A> withNewOAuthClientLike(OAuthClient item);
    public KubeSchemaFluent.OAuthClientNested<A> editOAuthClient();
    public KubeSchemaFluent.OAuthClientNested<A> editOrNewOAuthClient();
    public KubeSchemaFluent.OAuthClientNested<A> editOrNewOAuthClientLike(OAuthClient item);
    
/**
 * This method has been deprecated, please use method buildOAuthClientAuthorization instead.
 */
@Deprecated public OAuthClientAuthorization getOAuthClientAuthorization();
    public OAuthClientAuthorization buildOAuthClientAuthorization();
    public A withOAuthClientAuthorization(OAuthClientAuthorization oAuthClientAuthorization);
    public Boolean hasOAuthClientAuthorization();
    public KubeSchemaFluent.OAuthClientAuthorizationNested<A> withNewOAuthClientAuthorization();
    public KubeSchemaFluent.OAuthClientAuthorizationNested<A> withNewOAuthClientAuthorizationLike(OAuthClientAuthorization item);
    public KubeSchemaFluent.OAuthClientAuthorizationNested<A> editOAuthClientAuthorization();
    public KubeSchemaFluent.OAuthClientAuthorizationNested<A> editOrNewOAuthClientAuthorization();
    public KubeSchemaFluent.OAuthClientAuthorizationNested<A> editOrNewOAuthClientAuthorizationLike(OAuthClientAuthorization item);
    
/**
 * This method has been deprecated, please use method buildOAuthClientAuthorizationList instead.
 */
@Deprecated public OAuthClientAuthorizationList getOAuthClientAuthorizationList();
    public OAuthClientAuthorizationList buildOAuthClientAuthorizationList();
    public A withOAuthClientAuthorizationList(OAuthClientAuthorizationList oAuthClientAuthorizationList);
    public Boolean hasOAuthClientAuthorizationList();
    public KubeSchemaFluent.OAuthClientAuthorizationListNested<A> withNewOAuthClientAuthorizationList();
    public KubeSchemaFluent.OAuthClientAuthorizationListNested<A> withNewOAuthClientAuthorizationListLike(OAuthClientAuthorizationList item);
    public KubeSchemaFluent.OAuthClientAuthorizationListNested<A> editOAuthClientAuthorizationList();
    public KubeSchemaFluent.OAuthClientAuthorizationListNested<A> editOrNewOAuthClientAuthorizationList();
    public KubeSchemaFluent.OAuthClientAuthorizationListNested<A> editOrNewOAuthClientAuthorizationListLike(OAuthClientAuthorizationList item);
    
/**
 * This method has been deprecated, please use method buildOAuthClientList instead.
 */
@Deprecated public OAuthClientList getOAuthClientList();
    public OAuthClientList buildOAuthClientList();
    public A withOAuthClientList(OAuthClientList oAuthClientList);
    public Boolean hasOAuthClientList();
    public KubeSchemaFluent.OAuthClientListNested<A> withNewOAuthClientList();
    public KubeSchemaFluent.OAuthClientListNested<A> withNewOAuthClientListLike(OAuthClientList item);
    public KubeSchemaFluent.OAuthClientListNested<A> editOAuthClientList();
    public KubeSchemaFluent.OAuthClientListNested<A> editOrNewOAuthClientList();
    public KubeSchemaFluent.OAuthClientListNested<A> editOrNewOAuthClientListLike(OAuthClientList item);
    
/**
 * This method has been deprecated, please use method buildObjectMeta instead.
 */
@Deprecated public ObjectMeta getObjectMeta();
    public ObjectMeta buildObjectMeta();
    public A withObjectMeta(ObjectMeta objectMeta);
    public Boolean hasObjectMeta();
    public KubeSchemaFluent.ObjectMetaNested<A> withNewObjectMeta();
    public KubeSchemaFluent.ObjectMetaNested<A> withNewObjectMetaLike(ObjectMeta item);
    public KubeSchemaFluent.ObjectMetaNested<A> editObjectMeta();
    public KubeSchemaFluent.ObjectMetaNested<A> editOrNewObjectMeta();
    public KubeSchemaFluent.ObjectMetaNested<A> editOrNewObjectMetaLike(ObjectMeta item);
    
/**
 * This method has been deprecated, please use method buildPatch instead.
 */
@Deprecated public Patch getPatch();
    public Patch buildPatch();
    public A withPatch(Patch patch);
    public Boolean hasPatch();
    public KubeSchemaFluent.PatchNested<A> withNewPatch();
    public KubeSchemaFluent.PatchNested<A> withNewPatchLike(Patch item);
    public KubeSchemaFluent.PatchNested<A> editPatch();
    public KubeSchemaFluent.PatchNested<A> editOrNewPatch();
    public KubeSchemaFluent.PatchNested<A> editOrNewPatchLike(Patch item);
    
/**
 * This method has been deprecated, please use method buildPersistentVolume instead.
 */
@Deprecated public PersistentVolume getPersistentVolume();
    public PersistentVolume buildPersistentVolume();
    public A withPersistentVolume(PersistentVolume persistentVolume);
    public Boolean hasPersistentVolume();
    public KubeSchemaFluent.PersistentVolumeNested<A> withNewPersistentVolume();
    public KubeSchemaFluent.PersistentVolumeNested<A> withNewPersistentVolumeLike(PersistentVolume item);
    public KubeSchemaFluent.PersistentVolumeNested<A> editPersistentVolume();
    public KubeSchemaFluent.PersistentVolumeNested<A> editOrNewPersistentVolume();
    public KubeSchemaFluent.PersistentVolumeNested<A> editOrNewPersistentVolumeLike(PersistentVolume item);
    
/**
 * This method has been deprecated, please use method buildPersistentVolumeClaim instead.
 */
@Deprecated public PersistentVolumeClaim getPersistentVolumeClaim();
    public PersistentVolumeClaim buildPersistentVolumeClaim();
    public A withPersistentVolumeClaim(PersistentVolumeClaim persistentVolumeClaim);
    public Boolean hasPersistentVolumeClaim();
    public KubeSchemaFluent.PersistentVolumeClaimNested<A> withNewPersistentVolumeClaim();
    public KubeSchemaFluent.PersistentVolumeClaimNested<A> withNewPersistentVolumeClaimLike(PersistentVolumeClaim item);
    public KubeSchemaFluent.PersistentVolumeClaimNested<A> editPersistentVolumeClaim();
    public KubeSchemaFluent.PersistentVolumeClaimNested<A> editOrNewPersistentVolumeClaim();
    public KubeSchemaFluent.PersistentVolumeClaimNested<A> editOrNewPersistentVolumeClaimLike(PersistentVolumeClaim item);
    
/**
 * This method has been deprecated, please use method buildPersistentVolumeClaimList instead.
 */
@Deprecated public PersistentVolumeClaimList getPersistentVolumeClaimList();
    public PersistentVolumeClaimList buildPersistentVolumeClaimList();
    public A withPersistentVolumeClaimList(PersistentVolumeClaimList persistentVolumeClaimList);
    public Boolean hasPersistentVolumeClaimList();
    public KubeSchemaFluent.PersistentVolumeClaimListNested<A> withNewPersistentVolumeClaimList();
    public KubeSchemaFluent.PersistentVolumeClaimListNested<A> withNewPersistentVolumeClaimListLike(PersistentVolumeClaimList item);
    public KubeSchemaFluent.PersistentVolumeClaimListNested<A> editPersistentVolumeClaimList();
    public KubeSchemaFluent.PersistentVolumeClaimListNested<A> editOrNewPersistentVolumeClaimList();
    public KubeSchemaFluent.PersistentVolumeClaimListNested<A> editOrNewPersistentVolumeClaimListLike(PersistentVolumeClaimList item);
    
/**
 * This method has been deprecated, please use method buildPersistentVolumeList instead.
 */
@Deprecated public PersistentVolumeList getPersistentVolumeList();
    public PersistentVolumeList buildPersistentVolumeList();
    public A withPersistentVolumeList(PersistentVolumeList persistentVolumeList);
    public Boolean hasPersistentVolumeList();
    public KubeSchemaFluent.PersistentVolumeListNested<A> withNewPersistentVolumeList();
    public KubeSchemaFluent.PersistentVolumeListNested<A> withNewPersistentVolumeListLike(PersistentVolumeList item);
    public KubeSchemaFluent.PersistentVolumeListNested<A> editPersistentVolumeList();
    public KubeSchemaFluent.PersistentVolumeListNested<A> editOrNewPersistentVolumeList();
    public KubeSchemaFluent.PersistentVolumeListNested<A> editOrNewPersistentVolumeListLike(PersistentVolumeList item);
    
/**
 * This method has been deprecated, please use method buildPodDisruptionBudget instead.
 */
@Deprecated public PodDisruptionBudget getPodDisruptionBudget();
    public PodDisruptionBudget buildPodDisruptionBudget();
    public A withPodDisruptionBudget(PodDisruptionBudget podDisruptionBudget);
    public Boolean hasPodDisruptionBudget();
    public KubeSchemaFluent.PodDisruptionBudgetNested<A> withNewPodDisruptionBudget();
    public KubeSchemaFluent.PodDisruptionBudgetNested<A> withNewPodDisruptionBudgetLike(PodDisruptionBudget item);
    public KubeSchemaFluent.PodDisruptionBudgetNested<A> editPodDisruptionBudget();
    public KubeSchemaFluent.PodDisruptionBudgetNested<A> editOrNewPodDisruptionBudget();
    public KubeSchemaFluent.PodDisruptionBudgetNested<A> editOrNewPodDisruptionBudgetLike(PodDisruptionBudget item);
    
/**
 * This method has been deprecated, please use method buildPodDisruptionBudgetList instead.
 */
@Deprecated public PodDisruptionBudgetList getPodDisruptionBudgetList();
    public PodDisruptionBudgetList buildPodDisruptionBudgetList();
    public A withPodDisruptionBudgetList(PodDisruptionBudgetList podDisruptionBudgetList);
    public Boolean hasPodDisruptionBudgetList();
    public KubeSchemaFluent.PodDisruptionBudgetListNested<A> withNewPodDisruptionBudgetList();
    public KubeSchemaFluent.PodDisruptionBudgetListNested<A> withNewPodDisruptionBudgetListLike(PodDisruptionBudgetList item);
    public KubeSchemaFluent.PodDisruptionBudgetListNested<A> editPodDisruptionBudgetList();
    public KubeSchemaFluent.PodDisruptionBudgetListNested<A> editOrNewPodDisruptionBudgetList();
    public KubeSchemaFluent.PodDisruptionBudgetListNested<A> editOrNewPodDisruptionBudgetListLike(PodDisruptionBudgetList item);
    
/**
 * This method has been deprecated, please use method buildPodList instead.
 */
@Deprecated public PodList getPodList();
    public PodList buildPodList();
    public A withPodList(PodList podList);
    public Boolean hasPodList();
    public KubeSchemaFluent.PodListNested<A> withNewPodList();
    public KubeSchemaFluent.PodListNested<A> withNewPodListLike(PodList item);
    public KubeSchemaFluent.PodListNested<A> editPodList();
    public KubeSchemaFluent.PodListNested<A> editOrNewPodList();
    public KubeSchemaFluent.PodListNested<A> editOrNewPodListLike(PodList item);
    
/**
 * This method has been deprecated, please use method buildPodSecurityPolicy instead.
 */
@Deprecated public PodSecurityPolicy getPodSecurityPolicy();
    public PodSecurityPolicy buildPodSecurityPolicy();
    public A withPodSecurityPolicy(PodSecurityPolicy podSecurityPolicy);
    public Boolean hasPodSecurityPolicy();
    public KubeSchemaFluent.PodSecurityPolicyNested<A> withNewPodSecurityPolicy();
    public KubeSchemaFluent.PodSecurityPolicyNested<A> withNewPodSecurityPolicyLike(PodSecurityPolicy item);
    public KubeSchemaFluent.PodSecurityPolicyNested<A> editPodSecurityPolicy();
    public KubeSchemaFluent.PodSecurityPolicyNested<A> editOrNewPodSecurityPolicy();
    public KubeSchemaFluent.PodSecurityPolicyNested<A> editOrNewPodSecurityPolicyLike(PodSecurityPolicy item);
    
/**
 * This method has been deprecated, please use method buildPodSecurityPolicyList instead.
 */
@Deprecated public PodSecurityPolicyList getPodSecurityPolicyList();
    public PodSecurityPolicyList buildPodSecurityPolicyList();
    public A withPodSecurityPolicyList(PodSecurityPolicyList podSecurityPolicyList);
    public Boolean hasPodSecurityPolicyList();
    public KubeSchemaFluent.PodSecurityPolicyListNested<A> withNewPodSecurityPolicyList();
    public KubeSchemaFluent.PodSecurityPolicyListNested<A> withNewPodSecurityPolicyListLike(PodSecurityPolicyList item);
    public KubeSchemaFluent.PodSecurityPolicyListNested<A> editPodSecurityPolicyList();
    public KubeSchemaFluent.PodSecurityPolicyListNested<A> editOrNewPodSecurityPolicyList();
    public KubeSchemaFluent.PodSecurityPolicyListNested<A> editOrNewPodSecurityPolicyListLike(PodSecurityPolicyList item);
    
/**
 * This method has been deprecated, please use method buildPodTemplateList instead.
 */
@Deprecated public PodTemplateList getPodTemplateList();
    public PodTemplateList buildPodTemplateList();
    public A withPodTemplateList(PodTemplateList podTemplateList);
    public Boolean hasPodTemplateList();
    public KubeSchemaFluent.PodTemplateListNested<A> withNewPodTemplateList();
    public KubeSchemaFluent.PodTemplateListNested<A> withNewPodTemplateListLike(PodTemplateList item);
    public KubeSchemaFluent.PodTemplateListNested<A> editPodTemplateList();
    public KubeSchemaFluent.PodTemplateListNested<A> editOrNewPodTemplateList();
    public KubeSchemaFluent.PodTemplateListNested<A> editOrNewPodTemplateListLike(PodTemplateList item);
    
/**
 * This method has been deprecated, please use method buildPolicy instead.
 */
@Deprecated public Policy getPolicy();
    public Policy buildPolicy();
    public A withPolicy(Policy policy);
    public Boolean hasPolicy();
    public KubeSchemaFluent.PolicyNested<A> withNewPolicy();
    public KubeSchemaFluent.PolicyNested<A> withNewPolicyLike(Policy item);
    public KubeSchemaFluent.PolicyNested<A> editPolicy();
    public KubeSchemaFluent.PolicyNested<A> editOrNewPolicy();
    public KubeSchemaFluent.PolicyNested<A> editOrNewPolicyLike(Policy item);
    
/**
 * This method has been deprecated, please use method buildPolicyBinding instead.
 */
@Deprecated public PolicyBinding getPolicyBinding();
    public PolicyBinding buildPolicyBinding();
    public A withPolicyBinding(PolicyBinding policyBinding);
    public Boolean hasPolicyBinding();
    public KubeSchemaFluent.PolicyBindingNested<A> withNewPolicyBinding();
    public KubeSchemaFluent.PolicyBindingNested<A> withNewPolicyBindingLike(PolicyBinding item);
    public KubeSchemaFluent.PolicyBindingNested<A> editPolicyBinding();
    public KubeSchemaFluent.PolicyBindingNested<A> editOrNewPolicyBinding();
    public KubeSchemaFluent.PolicyBindingNested<A> editOrNewPolicyBindingLike(PolicyBinding item);
    
/**
 * This method has been deprecated, please use method buildPolicyBindingList instead.
 */
@Deprecated public PolicyBindingList getPolicyBindingList();
    public PolicyBindingList buildPolicyBindingList();
    public A withPolicyBindingList(PolicyBindingList policyBindingList);
    public Boolean hasPolicyBindingList();
    public KubeSchemaFluent.PolicyBindingListNested<A> withNewPolicyBindingList();
    public KubeSchemaFluent.PolicyBindingListNested<A> withNewPolicyBindingListLike(PolicyBindingList item);
    public KubeSchemaFluent.PolicyBindingListNested<A> editPolicyBindingList();
    public KubeSchemaFluent.PolicyBindingListNested<A> editOrNewPolicyBindingList();
    public KubeSchemaFluent.PolicyBindingListNested<A> editOrNewPolicyBindingListLike(PolicyBindingList item);
    
/**
 * This method has been deprecated, please use method buildPolicyList instead.
 */
@Deprecated public PolicyList getPolicyList();
    public PolicyList buildPolicyList();
    public A withPolicyList(PolicyList policyList);
    public Boolean hasPolicyList();
    public KubeSchemaFluent.PolicyListNested<A> withNewPolicyList();
    public KubeSchemaFluent.PolicyListNested<A> withNewPolicyListLike(PolicyList item);
    public KubeSchemaFluent.PolicyListNested<A> editPolicyList();
    public KubeSchemaFluent.PolicyListNested<A> editOrNewPolicyList();
    public KubeSchemaFluent.PolicyListNested<A> editOrNewPolicyListLike(PolicyList item);
    
/**
 * This method has been deprecated, please use method buildProject instead.
 */
@Deprecated public Project getProject();
    public Project buildProject();
    public A withProject(Project project);
    public Boolean hasProject();
    public KubeSchemaFluent.ProjectNested<A> withNewProject();
    public KubeSchemaFluent.ProjectNested<A> withNewProjectLike(Project item);
    public KubeSchemaFluent.ProjectNested<A> editProject();
    public KubeSchemaFluent.ProjectNested<A> editOrNewProject();
    public KubeSchemaFluent.ProjectNested<A> editOrNewProjectLike(Project item);
    
/**
 * This method has been deprecated, please use method buildProjectList instead.
 */
@Deprecated public ProjectList getProjectList();
    public ProjectList buildProjectList();
    public A withProjectList(ProjectList projectList);
    public Boolean hasProjectList();
    public KubeSchemaFluent.ProjectListNested<A> withNewProjectList();
    public KubeSchemaFluent.ProjectListNested<A> withNewProjectListLike(ProjectList item);
    public KubeSchemaFluent.ProjectListNested<A> editProjectList();
    public KubeSchemaFluent.ProjectListNested<A> editOrNewProjectList();
    public KubeSchemaFluent.ProjectListNested<A> editOrNewProjectListLike(ProjectList item);
    
/**
 * This method has been deprecated, please use method buildProjectRequest instead.
 */
@Deprecated public ProjectRequest getProjectRequest();
    public ProjectRequest buildProjectRequest();
    public A withProjectRequest(ProjectRequest projectRequest);
    public Boolean hasProjectRequest();
    public KubeSchemaFluent.ProjectRequestNested<A> withNewProjectRequest();
    public KubeSchemaFluent.ProjectRequestNested<A> withNewProjectRequestLike(ProjectRequest item);
    public KubeSchemaFluent.ProjectRequestNested<A> editProjectRequest();
    public KubeSchemaFluent.ProjectRequestNested<A> editOrNewProjectRequest();
    public KubeSchemaFluent.ProjectRequestNested<A> editOrNewProjectRequestLike(ProjectRequest item);
    
/**
 * This method has been deprecated, please use method buildQuantity instead.
 */
@Deprecated public Quantity getQuantity();
    public Quantity buildQuantity();
    public A withQuantity(Quantity quantity);
    public Boolean hasQuantity();
    public KubeSchemaFluent.QuantityNested<A> withNewQuantity();
    public KubeSchemaFluent.QuantityNested<A> withNewQuantityLike(Quantity item);
    public KubeSchemaFluent.QuantityNested<A> editQuantity();
    public KubeSchemaFluent.QuantityNested<A> editOrNewQuantity();
    public KubeSchemaFluent.QuantityNested<A> editOrNewQuantityLike(Quantity item);
    public A withNewQuantity(String amount);
    public A withNewQuantity(String amount,String format);
    
/**
 * This method has been deprecated, please use method buildReplicaSet instead.
 */
@Deprecated public ReplicaSet getReplicaSet();
    public ReplicaSet buildReplicaSet();
    public A withReplicaSet(ReplicaSet replicaSet);
    public Boolean hasReplicaSet();
    public KubeSchemaFluent.ReplicaSetNested<A> withNewReplicaSet();
    public KubeSchemaFluent.ReplicaSetNested<A> withNewReplicaSetLike(ReplicaSet item);
    public KubeSchemaFluent.ReplicaSetNested<A> editReplicaSet();
    public KubeSchemaFluent.ReplicaSetNested<A> editOrNewReplicaSet();
    public KubeSchemaFluent.ReplicaSetNested<A> editOrNewReplicaSetLike(ReplicaSet item);
    
/**
 * This method has been deprecated, please use method buildReplicaSetList instead.
 */
@Deprecated public ReplicaSetList getReplicaSetList();
    public ReplicaSetList buildReplicaSetList();
    public A withReplicaSetList(ReplicaSetList replicaSetList);
    public Boolean hasReplicaSetList();
    public KubeSchemaFluent.ReplicaSetListNested<A> withNewReplicaSetList();
    public KubeSchemaFluent.ReplicaSetListNested<A> withNewReplicaSetListLike(ReplicaSetList item);
    public KubeSchemaFluent.ReplicaSetListNested<A> editReplicaSetList();
    public KubeSchemaFluent.ReplicaSetListNested<A> editOrNewReplicaSetList();
    public KubeSchemaFluent.ReplicaSetListNested<A> editOrNewReplicaSetListLike(ReplicaSetList item);
    
/**
 * This method has been deprecated, please use method buildReplicationControllerList instead.
 */
@Deprecated public ReplicationControllerList getReplicationControllerList();
    public ReplicationControllerList buildReplicationControllerList();
    public A withReplicationControllerList(ReplicationControllerList replicationControllerList);
    public Boolean hasReplicationControllerList();
    public KubeSchemaFluent.ReplicationControllerListNested<A> withNewReplicationControllerList();
    public KubeSchemaFluent.ReplicationControllerListNested<A> withNewReplicationControllerListLike(ReplicationControllerList item);
    public KubeSchemaFluent.ReplicationControllerListNested<A> editReplicationControllerList();
    public KubeSchemaFluent.ReplicationControllerListNested<A> editOrNewReplicationControllerList();
    public KubeSchemaFluent.ReplicationControllerListNested<A> editOrNewReplicationControllerListLike(ReplicationControllerList item);
    
/**
 * This method has been deprecated, please use method buildResourceQuota instead.
 */
@Deprecated public ResourceQuota getResourceQuota();
    public ResourceQuota buildResourceQuota();
    public A withResourceQuota(ResourceQuota resourceQuota);
    public Boolean hasResourceQuota();
    public KubeSchemaFluent.ResourceQuotaNested<A> withNewResourceQuota();
    public KubeSchemaFluent.ResourceQuotaNested<A> withNewResourceQuotaLike(ResourceQuota item);
    public KubeSchemaFluent.ResourceQuotaNested<A> editResourceQuota();
    public KubeSchemaFluent.ResourceQuotaNested<A> editOrNewResourceQuota();
    public KubeSchemaFluent.ResourceQuotaNested<A> editOrNewResourceQuotaLike(ResourceQuota item);
    
/**
 * This method has been deprecated, please use method buildResourceQuotaList instead.
 */
@Deprecated public ResourceQuotaList getResourceQuotaList();
    public ResourceQuotaList buildResourceQuotaList();
    public A withResourceQuotaList(ResourceQuotaList resourceQuotaList);
    public Boolean hasResourceQuotaList();
    public KubeSchemaFluent.ResourceQuotaListNested<A> withNewResourceQuotaList();
    public KubeSchemaFluent.ResourceQuotaListNested<A> withNewResourceQuotaListLike(ResourceQuotaList item);
    public KubeSchemaFluent.ResourceQuotaListNested<A> editResourceQuotaList();
    public KubeSchemaFluent.ResourceQuotaListNested<A> editOrNewResourceQuotaList();
    public KubeSchemaFluent.ResourceQuotaListNested<A> editOrNewResourceQuotaListLike(ResourceQuotaList item);
    
/**
 * This method has been deprecated, please use method buildRole instead.
 */
@Deprecated public Role getRole();
    public Role buildRole();
    public A withRole(Role role);
    public Boolean hasRole();
    public KubeSchemaFluent.RoleNested<A> withNewRole();
    public KubeSchemaFluent.RoleNested<A> withNewRoleLike(Role item);
    public KubeSchemaFluent.RoleNested<A> editRole();
    public KubeSchemaFluent.RoleNested<A> editOrNewRole();
    public KubeSchemaFluent.RoleNested<A> editOrNewRoleLike(Role item);
    
/**
 * This method has been deprecated, please use method buildRoleBinding instead.
 */
@Deprecated public RoleBinding getRoleBinding();
    public RoleBinding buildRoleBinding();
    public A withRoleBinding(RoleBinding roleBinding);
    public Boolean hasRoleBinding();
    public KubeSchemaFluent.RoleBindingNested<A> withNewRoleBinding();
    public KubeSchemaFluent.RoleBindingNested<A> withNewRoleBindingLike(RoleBinding item);
    public KubeSchemaFluent.RoleBindingNested<A> editRoleBinding();
    public KubeSchemaFluent.RoleBindingNested<A> editOrNewRoleBinding();
    public KubeSchemaFluent.RoleBindingNested<A> editOrNewRoleBindingLike(RoleBinding item);
    
/**
 * This method has been deprecated, please use method buildRoleBindingList instead.
 */
@Deprecated public RoleBindingList getRoleBindingList();
    public RoleBindingList buildRoleBindingList();
    public A withRoleBindingList(RoleBindingList roleBindingList);
    public Boolean hasRoleBindingList();
    public KubeSchemaFluent.RoleBindingListNested<A> withNewRoleBindingList();
    public KubeSchemaFluent.RoleBindingListNested<A> withNewRoleBindingListLike(RoleBindingList item);
    public KubeSchemaFluent.RoleBindingListNested<A> editRoleBindingList();
    public KubeSchemaFluent.RoleBindingListNested<A> editOrNewRoleBindingList();
    public KubeSchemaFluent.RoleBindingListNested<A> editOrNewRoleBindingListLike(RoleBindingList item);
    
/**
 * This method has been deprecated, please use method buildRoleBindingRestriction instead.
 */
@Deprecated public RoleBindingRestriction getRoleBindingRestriction();
    public RoleBindingRestriction buildRoleBindingRestriction();
    public A withRoleBindingRestriction(RoleBindingRestriction roleBindingRestriction);
    public Boolean hasRoleBindingRestriction();
    public KubeSchemaFluent.RoleBindingRestrictionNested<A> withNewRoleBindingRestriction();
    public KubeSchemaFluent.RoleBindingRestrictionNested<A> withNewRoleBindingRestrictionLike(RoleBindingRestriction item);
    public KubeSchemaFluent.RoleBindingRestrictionNested<A> editRoleBindingRestriction();
    public KubeSchemaFluent.RoleBindingRestrictionNested<A> editOrNewRoleBindingRestriction();
    public KubeSchemaFluent.RoleBindingRestrictionNested<A> editOrNewRoleBindingRestrictionLike(RoleBindingRestriction item);
    
/**
 * This method has been deprecated, please use method buildRoleList instead.
 */
@Deprecated public RoleList getRoleList();
    public RoleList buildRoleList();
    public A withRoleList(RoleList roleList);
    public Boolean hasRoleList();
    public KubeSchemaFluent.RoleListNested<A> withNewRoleList();
    public KubeSchemaFluent.RoleListNested<A> withNewRoleListLike(RoleList item);
    public KubeSchemaFluent.RoleListNested<A> editRoleList();
    public KubeSchemaFluent.RoleListNested<A> editOrNewRoleList();
    public KubeSchemaFluent.RoleListNested<A> editOrNewRoleListLike(RoleList item);
    
/**
 * This method has been deprecated, please use method buildRootPaths instead.
 */
@Deprecated public RootPaths getRootPaths();
    public RootPaths buildRootPaths();
    public A withRootPaths(RootPaths rootPaths);
    public Boolean hasRootPaths();
    public KubeSchemaFluent.RootPathsNested<A> withNewRootPaths();
    public KubeSchemaFluent.RootPathsNested<A> withNewRootPathsLike(RootPaths item);
    public KubeSchemaFluent.RootPathsNested<A> editRootPaths();
    public KubeSchemaFluent.RootPathsNested<A> editOrNewRootPaths();
    public KubeSchemaFluent.RootPathsNested<A> editOrNewRootPathsLike(RootPaths item);
    
/**
 * This method has been deprecated, please use method buildRoute instead.
 */
@Deprecated public Route getRoute();
    public Route buildRoute();
    public A withRoute(Route route);
    public Boolean hasRoute();
    public KubeSchemaFluent.RouteNested<A> withNewRoute();
    public KubeSchemaFluent.RouteNested<A> withNewRouteLike(Route item);
    public KubeSchemaFluent.RouteNested<A> editRoute();
    public KubeSchemaFluent.RouteNested<A> editOrNewRoute();
    public KubeSchemaFluent.RouteNested<A> editOrNewRouteLike(Route item);
    
/**
 * This method has been deprecated, please use method buildRouteList instead.
 */
@Deprecated public RouteList getRouteList();
    public RouteList buildRouteList();
    public A withRouteList(RouteList routeList);
    public Boolean hasRouteList();
    public KubeSchemaFluent.RouteListNested<A> withNewRouteList();
    public KubeSchemaFluent.RouteListNested<A> withNewRouteListLike(RouteList item);
    public KubeSchemaFluent.RouteListNested<A> editRouteList();
    public KubeSchemaFluent.RouteListNested<A> editOrNewRouteList();
    public KubeSchemaFluent.RouteListNested<A> editOrNewRouteListLike(RouteList item);
    
/**
 * This method has been deprecated, please use method buildScale instead.
 */
@Deprecated public Scale getScale();
    public Scale buildScale();
    public A withScale(Scale scale);
    public Boolean hasScale();
    public KubeSchemaFluent.ScaleNested<A> withNewScale();
    public KubeSchemaFluent.ScaleNested<A> withNewScaleLike(Scale item);
    public KubeSchemaFluent.ScaleNested<A> editScale();
    public KubeSchemaFluent.ScaleNested<A> editOrNewScale();
    public KubeSchemaFluent.ScaleNested<A> editOrNewScaleLike(Scale item);
    
/**
 * This method has been deprecated, please use method buildSecret instead.
 */
@Deprecated public Secret getSecret();
    public Secret buildSecret();
    public A withSecret(Secret secret);
    public Boolean hasSecret();
    public KubeSchemaFluent.SecretNested<A> withNewSecret();
    public KubeSchemaFluent.SecretNested<A> withNewSecretLike(Secret item);
    public KubeSchemaFluent.SecretNested<A> editSecret();
    public KubeSchemaFluent.SecretNested<A> editOrNewSecret();
    public KubeSchemaFluent.SecretNested<A> editOrNewSecretLike(Secret item);
    
/**
 * This method has been deprecated, please use method buildSecretList instead.
 */
@Deprecated public SecretList getSecretList();
    public SecretList buildSecretList();
    public A withSecretList(SecretList secretList);
    public Boolean hasSecretList();
    public KubeSchemaFluent.SecretListNested<A> withNewSecretList();
    public KubeSchemaFluent.SecretListNested<A> withNewSecretListLike(SecretList item);
    public KubeSchemaFluent.SecretListNested<A> editSecretList();
    public KubeSchemaFluent.SecretListNested<A> editOrNewSecretList();
    public KubeSchemaFluent.SecretListNested<A> editOrNewSecretListLike(SecretList item);
    
/**
 * This method has been deprecated, please use method buildSecurityContextConstraints instead.
 */
@Deprecated public SecurityContextConstraints getSecurityContextConstraints();
    public SecurityContextConstraints buildSecurityContextConstraints();
    public A withSecurityContextConstraints(SecurityContextConstraints securityContextConstraints);
    public Boolean hasSecurityContextConstraints();
    public KubeSchemaFluent.SecurityContextConstraintsNested<A> withNewSecurityContextConstraints();
    public KubeSchemaFluent.SecurityContextConstraintsNested<A> withNewSecurityContextConstraintsLike(SecurityContextConstraints item);
    public KubeSchemaFluent.SecurityContextConstraintsNested<A> editSecurityContextConstraints();
    public KubeSchemaFluent.SecurityContextConstraintsNested<A> editOrNewSecurityContextConstraints();
    public KubeSchemaFluent.SecurityContextConstraintsNested<A> editOrNewSecurityContextConstraintsLike(SecurityContextConstraints item);
    
/**
 * This method has been deprecated, please use method buildSecurityContextConstraintsList instead.
 */
@Deprecated public SecurityContextConstraintsList getSecurityContextConstraintsList();
    public SecurityContextConstraintsList buildSecurityContextConstraintsList();
    public A withSecurityContextConstraintsList(SecurityContextConstraintsList securityContextConstraintsList);
    public Boolean hasSecurityContextConstraintsList();
    public KubeSchemaFluent.SecurityContextConstraintsListNested<A> withNewSecurityContextConstraintsList();
    public KubeSchemaFluent.SecurityContextConstraintsListNested<A> withNewSecurityContextConstraintsListLike(SecurityContextConstraintsList item);
    public KubeSchemaFluent.SecurityContextConstraintsListNested<A> editSecurityContextConstraintsList();
    public KubeSchemaFluent.SecurityContextConstraintsListNested<A> editOrNewSecurityContextConstraintsList();
    public KubeSchemaFluent.SecurityContextConstraintsListNested<A> editOrNewSecurityContextConstraintsListLike(SecurityContextConstraintsList item);
    
/**
 * This method has been deprecated, please use method buildServiceAccount instead.
 */
@Deprecated public ServiceAccount getServiceAccount();
    public ServiceAccount buildServiceAccount();
    public A withServiceAccount(ServiceAccount serviceAccount);
    public Boolean hasServiceAccount();
    public KubeSchemaFluent.ServiceAccountNested<A> withNewServiceAccount();
    public KubeSchemaFluent.ServiceAccountNested<A> withNewServiceAccountLike(ServiceAccount item);
    public KubeSchemaFluent.ServiceAccountNested<A> editServiceAccount();
    public KubeSchemaFluent.ServiceAccountNested<A> editOrNewServiceAccount();
    public KubeSchemaFluent.ServiceAccountNested<A> editOrNewServiceAccountLike(ServiceAccount item);
    
/**
 * This method has been deprecated, please use method buildServiceAccountList instead.
 */
@Deprecated public ServiceAccountList getServiceAccountList();
    public ServiceAccountList buildServiceAccountList();
    public A withServiceAccountList(ServiceAccountList serviceAccountList);
    public Boolean hasServiceAccountList();
    public KubeSchemaFluent.ServiceAccountListNested<A> withNewServiceAccountList();
    public KubeSchemaFluent.ServiceAccountListNested<A> withNewServiceAccountListLike(ServiceAccountList item);
    public KubeSchemaFluent.ServiceAccountListNested<A> editServiceAccountList();
    public KubeSchemaFluent.ServiceAccountListNested<A> editOrNewServiceAccountList();
    public KubeSchemaFluent.ServiceAccountListNested<A> editOrNewServiceAccountListLike(ServiceAccountList item);
    
/**
 * This method has been deprecated, please use method buildServiceList instead.
 */
@Deprecated public ServiceList getServiceList();
    public ServiceList buildServiceList();
    public A withServiceList(ServiceList serviceList);
    public Boolean hasServiceList();
    public KubeSchemaFluent.ServiceListNested<A> withNewServiceList();
    public KubeSchemaFluent.ServiceListNested<A> withNewServiceListLike(ServiceList item);
    public KubeSchemaFluent.ServiceListNested<A> editServiceList();
    public KubeSchemaFluent.ServiceListNested<A> editOrNewServiceList();
    public KubeSchemaFluent.ServiceListNested<A> editOrNewServiceListLike(ServiceList item);
    
/**
 * This method has been deprecated, please use method buildStatefulSet instead.
 */
@Deprecated public StatefulSet getStatefulSet();
    public StatefulSet buildStatefulSet();
    public A withStatefulSet(StatefulSet statefulSet);
    public Boolean hasStatefulSet();
    public KubeSchemaFluent.StatefulSetNested<A> withNewStatefulSet();
    public KubeSchemaFluent.StatefulSetNested<A> withNewStatefulSetLike(StatefulSet item);
    public KubeSchemaFluent.StatefulSetNested<A> editStatefulSet();
    public KubeSchemaFluent.StatefulSetNested<A> editOrNewStatefulSet();
    public KubeSchemaFluent.StatefulSetNested<A> editOrNewStatefulSetLike(StatefulSet item);
    
/**
 * This method has been deprecated, please use method buildStatefulSetList instead.
 */
@Deprecated public StatefulSetList getStatefulSetList();
    public StatefulSetList buildStatefulSetList();
    public A withStatefulSetList(StatefulSetList statefulSetList);
    public Boolean hasStatefulSetList();
    public KubeSchemaFluent.StatefulSetListNested<A> withNewStatefulSetList();
    public KubeSchemaFluent.StatefulSetListNested<A> withNewStatefulSetListLike(StatefulSetList item);
    public KubeSchemaFluent.StatefulSetListNested<A> editStatefulSetList();
    public KubeSchemaFluent.StatefulSetListNested<A> editOrNewStatefulSetList();
    public KubeSchemaFluent.StatefulSetListNested<A> editOrNewStatefulSetListLike(StatefulSetList item);
    
/**
 * This method has been deprecated, please use method buildStatus instead.
 */
@Deprecated public Status getStatus();
    public Status buildStatus();
    public A withStatus(Status status);
    public Boolean hasStatus();
    public KubeSchemaFluent.StatusNested<A> withNewStatus();
    public KubeSchemaFluent.StatusNested<A> withNewStatusLike(Status item);
    public KubeSchemaFluent.StatusNested<A> editStatus();
    public KubeSchemaFluent.StatusNested<A> editOrNewStatus();
    public KubeSchemaFluent.StatusNested<A> editOrNewStatusLike(Status item);
    
/**
 * This method has been deprecated, please use method buildStorageClass instead.
 */
@Deprecated public StorageClass getStorageClass();
    public StorageClass buildStorageClass();
    public A withStorageClass(StorageClass storageClass);
    public Boolean hasStorageClass();
    public KubeSchemaFluent.StorageClassNested<A> withNewStorageClass();
    public KubeSchemaFluent.StorageClassNested<A> withNewStorageClassLike(StorageClass item);
    public KubeSchemaFluent.StorageClassNested<A> editStorageClass();
    public KubeSchemaFluent.StorageClassNested<A> editOrNewStorageClass();
    public KubeSchemaFluent.StorageClassNested<A> editOrNewStorageClassLike(StorageClass item);
    
/**
 * This method has been deprecated, please use method buildStorageClassList instead.
 */
@Deprecated public StorageClassList getStorageClassList();
    public StorageClassList buildStorageClassList();
    public A withStorageClassList(StorageClassList storageClassList);
    public Boolean hasStorageClassList();
    public KubeSchemaFluent.StorageClassListNested<A> withNewStorageClassList();
    public KubeSchemaFluent.StorageClassListNested<A> withNewStorageClassListLike(StorageClassList item);
    public KubeSchemaFluent.StorageClassListNested<A> editStorageClassList();
    public KubeSchemaFluent.StorageClassListNested<A> editOrNewStorageClassList();
    public KubeSchemaFluent.StorageClassListNested<A> editOrNewStorageClassListLike(StorageClassList item);
    
/**
 * This method has been deprecated, please use method buildSubjectAccessReview instead.
 */
@Deprecated public io.fabric8.openshift.api.model.SubjectAccessReview getSubjectAccessReview();
    public io.fabric8.openshift.api.model.SubjectAccessReview buildSubjectAccessReview();
    public A withSubjectAccessReview(io.fabric8.openshift.api.model.SubjectAccessReview subjectAccessReview);
    public Boolean hasSubjectAccessReview();
    public KubeSchemaFluent.ModelSubjectAccessReviewNested<A> withNewModelSubjectAccessReview();
    public KubeSchemaFluent.ModelSubjectAccessReviewNested<A> withNewSubjectAccessReviewLike(io.fabric8.openshift.api.model.SubjectAccessReview item);
    public KubeSchemaFluent.ModelSubjectAccessReviewNested<A> editModelSubjectAccessReview();
    public KubeSchemaFluent.ModelSubjectAccessReviewNested<A> editOrNewSubjectAccessReview();
    public KubeSchemaFluent.ModelSubjectAccessReviewNested<A> editOrNewSubjectAccessReviewLike(io.fabric8.openshift.api.model.SubjectAccessReview item);
    
/**
 * This method has been deprecated, please use method buildSubjectAccessReviewResponse instead.
 */
@Deprecated public SubjectAccessReviewResponse getSubjectAccessReviewResponse();
    public SubjectAccessReviewResponse buildSubjectAccessReviewResponse();
    public A withSubjectAccessReviewResponse(SubjectAccessReviewResponse subjectAccessReviewResponse);
    public Boolean hasSubjectAccessReviewResponse();
    public KubeSchemaFluent.SubjectAccessReviewResponseNested<A> withNewSubjectAccessReviewResponse();
    public KubeSchemaFluent.SubjectAccessReviewResponseNested<A> withNewSubjectAccessReviewResponseLike(SubjectAccessReviewResponse item);
    public KubeSchemaFluent.SubjectAccessReviewResponseNested<A> editSubjectAccessReviewResponse();
    public KubeSchemaFluent.SubjectAccessReviewResponseNested<A> editOrNewSubjectAccessReviewResponse();
    public KubeSchemaFluent.SubjectAccessReviewResponseNested<A> editOrNewSubjectAccessReviewResponseLike(SubjectAccessReviewResponse item);
    
/**
 * This method has been deprecated, please use method buildTagEvent instead.
 */
@Deprecated public TagEvent getTagEvent();
    public TagEvent buildTagEvent();
    public A withTagEvent(TagEvent tagEvent);
    public Boolean hasTagEvent();
    public KubeSchemaFluent.TagEventNested<A> withNewTagEvent();
    public KubeSchemaFluent.TagEventNested<A> withNewTagEventLike(TagEvent item);
    public KubeSchemaFluent.TagEventNested<A> editTagEvent();
    public KubeSchemaFluent.TagEventNested<A> editOrNewTagEvent();
    public KubeSchemaFluent.TagEventNested<A> editOrNewTagEventLike(TagEvent item);
    public A withNewTagEvent(String created,String dockerImageReference,Long generation,String image);
    
/**
 * This method has been deprecated, please use method buildTemplate instead.
 */
@Deprecated public Template getTemplate();
    public Template buildTemplate();
    public A withTemplate(Template template);
    public Boolean hasTemplate();
    public KubeSchemaFluent.TemplateNested<A> withNewTemplate();
    public KubeSchemaFluent.TemplateNested<A> withNewTemplateLike(Template item);
    public KubeSchemaFluent.TemplateNested<A> editTemplate();
    public KubeSchemaFluent.TemplateNested<A> editOrNewTemplate();
    public KubeSchemaFluent.TemplateNested<A> editOrNewTemplateLike(Template item);
    
/**
 * This method has been deprecated, please use method buildTemplateList instead.
 */
@Deprecated public TemplateList getTemplateList();
    public TemplateList buildTemplateList();
    public A withTemplateList(TemplateList templateList);
    public Boolean hasTemplateList();
    public KubeSchemaFluent.TemplateListNested<A> withNewTemplateList();
    public KubeSchemaFluent.TemplateListNested<A> withNewTemplateListLike(TemplateList item);
    public KubeSchemaFluent.TemplateListNested<A> editTemplateList();
    public KubeSchemaFluent.TemplateListNested<A> editOrNewTemplateList();
    public KubeSchemaFluent.TemplateListNested<A> editOrNewTemplateListLike(TemplateList item);
    
/**
 * This method has been deprecated, please use method buildThirdPartyResource instead.
 */
@Deprecated public ThirdPartyResource getThirdPartyResource();
    public ThirdPartyResource buildThirdPartyResource();
    public A withThirdPartyResource(ThirdPartyResource thirdPartyResource);
    public Boolean hasThirdPartyResource();
    public KubeSchemaFluent.ThirdPartyResourceNested<A> withNewThirdPartyResource();
    public KubeSchemaFluent.ThirdPartyResourceNested<A> withNewThirdPartyResourceLike(ThirdPartyResource item);
    public KubeSchemaFluent.ThirdPartyResourceNested<A> editThirdPartyResource();
    public KubeSchemaFluent.ThirdPartyResourceNested<A> editOrNewThirdPartyResource();
    public KubeSchemaFluent.ThirdPartyResourceNested<A> editOrNewThirdPartyResourceLike(ThirdPartyResource item);
    
/**
 * This method has been deprecated, please use method buildThirdPartyResourceList instead.
 */
@Deprecated public ThirdPartyResourceList getThirdPartyResourceList();
    public ThirdPartyResourceList buildThirdPartyResourceList();
    public A withThirdPartyResourceList(ThirdPartyResourceList thirdPartyResourceList);
    public Boolean hasThirdPartyResourceList();
    public KubeSchemaFluent.ThirdPartyResourceListNested<A> withNewThirdPartyResourceList();
    public KubeSchemaFluent.ThirdPartyResourceListNested<A> withNewThirdPartyResourceListLike(ThirdPartyResourceList item);
    public KubeSchemaFluent.ThirdPartyResourceListNested<A> editThirdPartyResourceList();
    public KubeSchemaFluent.ThirdPartyResourceListNested<A> editOrNewThirdPartyResourceList();
    public KubeSchemaFluent.ThirdPartyResourceListNested<A> editOrNewThirdPartyResourceListLike(ThirdPartyResourceList item);
    
/**
 * This method has been deprecated, please use method buildTokenReview instead.
 */
@Deprecated public TokenReview getTokenReview();
    public TokenReview buildTokenReview();
    public A withTokenReview(TokenReview tokenReview);
    public Boolean hasTokenReview();
    public KubeSchemaFluent.TokenReviewNested<A> withNewTokenReview();
    public KubeSchemaFluent.TokenReviewNested<A> withNewTokenReviewLike(TokenReview item);
    public KubeSchemaFluent.TokenReviewNested<A> editTokenReview();
    public KubeSchemaFluent.TokenReviewNested<A> editOrNewTokenReview();
    public KubeSchemaFluent.TokenReviewNested<A> editOrNewTokenReviewLike(TokenReview item);
    
/**
 * This method has been deprecated, please use method buildToleration instead.
 */
@Deprecated public Toleration getToleration();
    public Toleration buildToleration();
    public A withToleration(Toleration toleration);
    public Boolean hasToleration();
    public KubeSchemaFluent.TolerationNested<A> withNewToleration();
    public KubeSchemaFluent.TolerationNested<A> withNewTolerationLike(Toleration item);
    public KubeSchemaFluent.TolerationNested<A> editToleration();
    public KubeSchemaFluent.TolerationNested<A> editOrNewToleration();
    public KubeSchemaFluent.TolerationNested<A> editOrNewTolerationLike(Toleration item);
    public A withNewToleration(String effect,String key,String operator,Long tolerationSeconds,String value);
    
/**
 * This method has been deprecated, please use method buildTypeMeta instead.
 */
@Deprecated public TypeMeta getTypeMeta();
    public TypeMeta buildTypeMeta();
    public A withTypeMeta(TypeMeta typeMeta);
    public Boolean hasTypeMeta();
    public KubeSchemaFluent.TypeMetaNested<A> withNewTypeMeta();
    public KubeSchemaFluent.TypeMetaNested<A> withNewTypeMetaLike(TypeMeta item);
    public KubeSchemaFluent.TypeMetaNested<A> editTypeMeta();
    public KubeSchemaFluent.TypeMetaNested<A> editOrNewTypeMeta();
    public KubeSchemaFluent.TypeMetaNested<A> editOrNewTypeMetaLike(TypeMeta item);
    public A withNewTypeMeta(String apiVersion,String kind);
    
/**
 * This method has been deprecated, please use method buildUser instead.
 */
@Deprecated public User getUser();
    public User buildUser();
    public A withUser(User user);
    public Boolean hasUser();
    public KubeSchemaFluent.UserNested<A> withNewUser();
    public KubeSchemaFluent.UserNested<A> withNewUserLike(User item);
    public KubeSchemaFluent.UserNested<A> editUser();
    public KubeSchemaFluent.UserNested<A> editOrNewUser();
    public KubeSchemaFluent.UserNested<A> editOrNewUserLike(User item);
    
/**
 * This method has been deprecated, please use method buildUserList instead.
 */
@Deprecated public UserList getUserList();
    public UserList buildUserList();
    public A withUserList(UserList userList);
    public Boolean hasUserList();
    public KubeSchemaFluent.UserListNested<A> withNewUserList();
    public KubeSchemaFluent.UserListNested<A> withNewUserListLike(UserList item);
    public KubeSchemaFluent.UserListNested<A> editUserList();
    public KubeSchemaFluent.UserListNested<A> editOrNewUserList();
    public KubeSchemaFluent.UserListNested<A> editOrNewUserListLike(UserList item);
    
/**
 * This method has been deprecated, please use method buildWatchEvent instead.
 */
@Deprecated public WatchEvent getWatchEvent();
    public WatchEvent buildWatchEvent();
    public A withWatchEvent(WatchEvent watchEvent);
    public Boolean hasWatchEvent();
    public KubeSchemaFluent.WatchEventNested<A> withNewWatchEvent();
    public KubeSchemaFluent.WatchEventNested<A> withNewWatchEventLike(WatchEvent item);
    public KubeSchemaFluent.WatchEventNested<A> editWatchEvent();
    public KubeSchemaFluent.WatchEventNested<A> editOrNewWatchEvent();
    public KubeSchemaFluent.WatchEventNested<A> editOrNewWatchEventLike(WatchEvent item);

    public interface BaseKubernetesListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,BaseKubernetesListFluent<KubeSchemaFluent.BaseKubernetesListNested<N>>{

        
    public N and();    public N endBaseKubernetesList();
}
    public interface BindingNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,BindingFluent<KubeSchemaFluent.BindingNested<N>>{

        
    public N and();    public N endBinding();
}
    public interface BuildConfigListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,BuildConfigListFluent<KubeSchemaFluent.BuildConfigListNested<N>>{

        
    public N and();    public N endBuildConfigList();
}
    public interface BuildListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,BuildListFluent<KubeSchemaFluent.BuildListNested<N>>{

        
    public N and();    public N endBuildList();
}
    public interface BuildRequestNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,BuildRequestFluent<KubeSchemaFluent.BuildRequestNested<N>>{

        
    public N and();    public N endBuildRequest();
}
    public interface ClusterPolicyNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ClusterPolicyFluent<KubeSchemaFluent.ClusterPolicyNested<N>>{

        
    public N and();    public N endClusterPolicy();
}
    public interface ClusterPolicyBindingNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ClusterPolicyBindingFluent<KubeSchemaFluent.ClusterPolicyBindingNested<N>>{

        
    public N and();    public N endClusterPolicyBinding();
}
    public interface ClusterPolicyBindingListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ClusterPolicyBindingListFluent<KubeSchemaFluent.ClusterPolicyBindingListNested<N>>{

        
    public N and();    public N endClusterPolicyBindingList();
}
    public interface ClusterPolicyListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ClusterPolicyListFluent<KubeSchemaFluent.ClusterPolicyListNested<N>>{

        
    public N and();    public N endClusterPolicyList();
}
    public interface ClusterRoleBindingNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ClusterRoleBindingFluent<KubeSchemaFluent.ClusterRoleBindingNested<N>>{

        
    public N and();    public N endClusterRoleBinding();
}
    public interface ClusterRoleBindingListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ClusterRoleBindingListFluent<KubeSchemaFluent.ClusterRoleBindingListNested<N>>{

        
    public N and();    public N endClusterRoleBindingList();
}
    public interface ComponentStatusListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ComponentStatusListFluent<KubeSchemaFluent.ComponentStatusListNested<N>>{

        
    public N and();    public N endComponentStatusList();
}
    public interface ConfigNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ConfigFluent<KubeSchemaFluent.ConfigNested<N>>{

        
    public N and();    public N endConfig();
}
    public interface ConfigMapNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ConfigMapFluent<KubeSchemaFluent.ConfigMapNested<N>>{

        
    public N and();    public N endConfigMap();
}
    public interface ConfigMapListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ConfigMapListFluent<KubeSchemaFluent.ConfigMapListNested<N>>{

        
    public N and();    public N endConfigMapList();
}
    public interface ContainerStatusNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ContainerStatusFluent<KubeSchemaFluent.ContainerStatusNested<N>>{

        
    public N and();    public N endContainerStatus();
}
    public interface CronJobNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,CronJobFluent<KubeSchemaFluent.CronJobNested<N>>{

        
    public N and();    public N endCronJob();
}
    public interface CronJobListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,CronJobListFluent<KubeSchemaFluent.CronJobListNested<N>>{

        
    public N and();    public N endCronJobList();
}
    public interface CustomResourceDefinitionNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,CustomResourceDefinitionFluent<KubeSchemaFluent.CustomResourceDefinitionNested<N>>{

        
    public N and();    public N endCustomResourceDefinition();
}
    public interface CustomResourceDefinitionConditionNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,CustomResourceDefinitionConditionFluent<KubeSchemaFluent.CustomResourceDefinitionConditionNested<N>>{

        
    public N and();    public N endCustomResourceDefinitionCondition();
}
    public interface CustomResourceDefinitionListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,CustomResourceDefinitionListFluent<KubeSchemaFluent.CustomResourceDefinitionListNested<N>>{

        
    public N and();    public N endCustomResourceDefinitionList();
}
    public interface CustomResourceDefinitionNamesNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,CustomResourceDefinitionNamesFluent<KubeSchemaFluent.CustomResourceDefinitionNamesNested<N>>{

        
    public N and();    public N endCustomResourceDefinitionNames();
}
    public interface CustomResourceDefinitionSpecNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,CustomResourceDefinitionSpecFluent<KubeSchemaFluent.CustomResourceDefinitionSpecNested<N>>{

        
    public N and();    public N endCustomResourceDefinitionSpec();
}
    public interface CustomResourceDefinitionStatusNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,CustomResourceDefinitionStatusFluent<KubeSchemaFluent.CustomResourceDefinitionStatusNested<N>>{

        
    public N and();    public N endCustomResourceDefinitionStatus();
}
    public interface DaemonSetNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,DaemonSetFluent<KubeSchemaFluent.DaemonSetNested<N>>{

        
    public N and();    public N endDaemonSet();
}
    public interface DaemonSetListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,DaemonSetListFluent<KubeSchemaFluent.DaemonSetListNested<N>>{

        
    public N and();    public N endDaemonSetList();
}
    public interface DeleteOptionsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,DeleteOptionsFluent<KubeSchemaFluent.DeleteOptionsNested<N>>{

        
    public N and();    public N endDeleteOptions();
}
    public interface DeploymentNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,DeploymentFluent<KubeSchemaFluent.DeploymentNested<N>>{

        
    public N and();    public N endDeployment();
}
    public interface DeploymentConfigNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,DeploymentConfigFluent<KubeSchemaFluent.DeploymentConfigNested<N>>{

        
    public N and();    public N endDeploymentConfig();
}
    public interface DeploymentConfigListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,DeploymentConfigListFluent<KubeSchemaFluent.DeploymentConfigListNested<N>>{

        
    public N and();    public N endDeploymentConfigList();
}
    public interface DeploymentListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,DeploymentListFluent<KubeSchemaFluent.DeploymentListNested<N>>{

        
    public N and();    public N endDeploymentList();
}
    public interface DeploymentRollbackNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,DeploymentRollbackFluent<KubeSchemaFluent.DeploymentRollbackNested<N>>{

        
    public N and();    public N endDeploymentRollback();
}
    public interface EndpointsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,EndpointsFluent<KubeSchemaFluent.EndpointsNested<N>>{

        
    public N and();    public N endEndpoints();
}
    public interface EndpointsListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,EndpointsListFluent<KubeSchemaFluent.EndpointsListNested<N>>{

        
    public N and();    public N endEndpointsList();
}
    public interface EnvVarNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,EnvVarFluent<KubeSchemaFluent.EnvVarNested<N>>{

        
    public N and();    public N endEnvVar();
}
    public interface EventListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,EventListFluent<KubeSchemaFluent.EventListNested<N>>{

        
    public N and();    public N endEventList();
}
    public interface GroupNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,GroupFluent<KubeSchemaFluent.GroupNested<N>>{

        
    public N and();    public N endGroup();
}
    public interface GroupListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,GroupListFluent<KubeSchemaFluent.GroupListNested<N>>{

        
    public N and();    public N endGroupList();
}
    public interface HorizontalPodAutoscalerNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,HorizontalPodAutoscalerFluent<KubeSchemaFluent.HorizontalPodAutoscalerNested<N>>{

        
    public N and();    public N endHorizontalPodAutoscaler();
}
    public interface HorizontalPodAutoscalerListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,HorizontalPodAutoscalerListFluent<KubeSchemaFluent.HorizontalPodAutoscalerListNested<N>>{

        
    public N and();    public N endHorizontalPodAutoscalerList();
}
    public interface IdentityNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,IdentityFluent<KubeSchemaFluent.IdentityNested<N>>{

        
    public N and();    public N endIdentity();
}
    public interface IdentityListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,IdentityListFluent<KubeSchemaFluent.IdentityListNested<N>>{

        
    public N and();    public N endIdentityList();
}
    public interface ImageListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ImageListFluent<KubeSchemaFluent.ImageListNested<N>>{

        
    public N and();    public N endImageList();
}
    public interface ImageStreamListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ImageStreamListFluent<KubeSchemaFluent.ImageStreamListNested<N>>{

        
    public N and();    public N endImageStreamList();
}
    public interface ImageStreamTagListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ImageStreamTagListFluent<KubeSchemaFluent.ImageStreamTagListNested<N>>{

        
    public N and();    public N endImageStreamTagList();
}
    public interface InfoNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,InfoFluent<KubeSchemaFluent.InfoNested<N>>{

        
    public N and();    public N endInfo();
}
    public interface IngressNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,IngressFluent<KubeSchemaFluent.IngressNested<N>>{

        
    public N and();    public N endIngress();
}
    public interface IngressListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,IngressListFluent<KubeSchemaFluent.IngressListNested<N>>{

        
    public N and();    public N endIngressList();
}
    public interface InitializerNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,InitializerFluent<KubeSchemaFluent.InitializerNested<N>>{

        
    public N and();    public N endInitializer();
}
    public interface InitializersNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,InitializersFluent<KubeSchemaFluent.InitializersNested<N>>{

        
    public N and();    public N endInitializers();
}
    public interface JobNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,JobFluent<KubeSchemaFluent.JobNested<N>>{

        
    public N and();    public N endJob();
}
    public interface JobListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,JobListFluent<KubeSchemaFluent.JobListNested<N>>{

        
    public N and();    public N endJobList();
}
    public interface K8sLocalSubjectAccessReviewNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,LocalSubjectAccessReviewFluent<KubeSchemaFluent.K8sLocalSubjectAccessReviewNested<N>>{

        
    public N and();    public N endK8sLocalSubjectAccessReview();
}
    public interface K8sSubjectAccessReviewNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,SubjectAccessReviewFluent<KubeSchemaFluent.K8sSubjectAccessReviewNested<N>>{

        
    public N and();    public N endK8sSubjectAccessReview();
}
    public interface LimitRangeListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,LimitRangeListFluent<KubeSchemaFluent.LimitRangeListNested<N>>{

        
    public N and();    public N endLimitRangeList();
}
    public interface ListMetaNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ListMetaFluent<KubeSchemaFluent.ListMetaNested<N>>{

        
    public N and();    public N endListMeta();
}
    public interface ModelLocalSubjectAccessReviewNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.openshift.api.model.LocalSubjectAccessReviewFluent<KubeSchemaFluent.ModelLocalSubjectAccessReviewNested<N>>{

        
    public N and();    public N endModelLocalSubjectAccessReview();
}
    public interface NamespaceNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,NamespaceFluent<KubeSchemaFluent.NamespaceNested<N>>{

        
    public N and();    public N endNamespace();
}
    public interface NamespaceListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,NamespaceListFluent<KubeSchemaFluent.NamespaceListNested<N>>{

        
    public N and();    public N endNamespaceList();
}
    public interface NetworkPolicyNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,NetworkPolicyFluent<KubeSchemaFluent.NetworkPolicyNested<N>>{

        
    public N and();    public N endNetworkPolicy();
}
    public interface NetworkPolicyListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,NetworkPolicyListFluent<KubeSchemaFluent.NetworkPolicyListNested<N>>{

        
    public N and();    public N endNetworkPolicyList();
}
    public interface NodeNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,NodeFluent<KubeSchemaFluent.NodeNested<N>>{

        
    public N and();    public N endNode();
}
    public interface NodeListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,NodeListFluent<KubeSchemaFluent.NodeListNested<N>>{

        
    public N and();    public N endNodeList();
}
    public interface OAuthAccessTokenNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,OAuthAccessTokenFluent<KubeSchemaFluent.OAuthAccessTokenNested<N>>{

        
    public N and();    public N endOAuthAccessToken();
}
    public interface OAuthAccessTokenListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,OAuthAccessTokenListFluent<KubeSchemaFluent.OAuthAccessTokenListNested<N>>{

        
    public N and();    public N endOAuthAccessTokenList();
}
    public interface OAuthAuthorizeTokenNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,OAuthAuthorizeTokenFluent<KubeSchemaFluent.OAuthAuthorizeTokenNested<N>>{

        
    public N and();    public N endOAuthAuthorizeToken();
}
    public interface OAuthAuthorizeTokenListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,OAuthAuthorizeTokenListFluent<KubeSchemaFluent.OAuthAuthorizeTokenListNested<N>>{

        
    public N and();    public N endOAuthAuthorizeTokenList();
}
    public interface OAuthClientNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,OAuthClientFluent<KubeSchemaFluent.OAuthClientNested<N>>{

        
    public N and();    public N endOAuthClient();
}
    public interface OAuthClientAuthorizationNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,OAuthClientAuthorizationFluent<KubeSchemaFluent.OAuthClientAuthorizationNested<N>>{

        
    public N and();    public N endOAuthClientAuthorization();
}
    public interface OAuthClientAuthorizationListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,OAuthClientAuthorizationListFluent<KubeSchemaFluent.OAuthClientAuthorizationListNested<N>>{

        
    public N and();    public N endOAuthClientAuthorizationList();
}
    public interface OAuthClientListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,OAuthClientListFluent<KubeSchemaFluent.OAuthClientListNested<N>>{

        
    public N and();    public N endOAuthClientList();
}
    public interface ObjectMetaNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ObjectMetaFluent<KubeSchemaFluent.ObjectMetaNested<N>>{

        
    public N and();    public N endObjectMeta();
}
    public interface PatchNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PatchFluent<KubeSchemaFluent.PatchNested<N>>{

        
    public N and();    public N endPatch();
}
    public interface PersistentVolumeNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PersistentVolumeFluent<KubeSchemaFluent.PersistentVolumeNested<N>>{

        
    public N and();    public N endPersistentVolume();
}
    public interface PersistentVolumeClaimNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PersistentVolumeClaimFluent<KubeSchemaFluent.PersistentVolumeClaimNested<N>>{

        
    public N and();    public N endPersistentVolumeClaim();
}
    public interface PersistentVolumeClaimListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PersistentVolumeClaimListFluent<KubeSchemaFluent.PersistentVolumeClaimListNested<N>>{

        
    public N and();    public N endPersistentVolumeClaimList();
}
    public interface PersistentVolumeListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PersistentVolumeListFluent<KubeSchemaFluent.PersistentVolumeListNested<N>>{

        
    public N and();    public N endPersistentVolumeList();
}
    public interface PodDisruptionBudgetNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PodDisruptionBudgetFluent<KubeSchemaFluent.PodDisruptionBudgetNested<N>>{

        
    public N and();    public N endPodDisruptionBudget();
}
    public interface PodDisruptionBudgetListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PodDisruptionBudgetListFluent<KubeSchemaFluent.PodDisruptionBudgetListNested<N>>{

        
    public N and();    public N endPodDisruptionBudgetList();
}
    public interface PodListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PodListFluent<KubeSchemaFluent.PodListNested<N>>{

        
    public N and();    public N endPodList();
}
    public interface PodSecurityPolicyNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PodSecurityPolicyFluent<KubeSchemaFluent.PodSecurityPolicyNested<N>>{

        
    public N and();    public N endPodSecurityPolicy();
}
    public interface PodSecurityPolicyListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PodSecurityPolicyListFluent<KubeSchemaFluent.PodSecurityPolicyListNested<N>>{

        
    public N and();    public N endPodSecurityPolicyList();
}
    public interface PodTemplateListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PodTemplateListFluent<KubeSchemaFluent.PodTemplateListNested<N>>{

        
    public N and();    public N endPodTemplateList();
}
    public interface PolicyNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PolicyFluent<KubeSchemaFluent.PolicyNested<N>>{

        
    public N and();    public N endPolicy();
}
    public interface PolicyBindingNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PolicyBindingFluent<KubeSchemaFluent.PolicyBindingNested<N>>{

        
    public N and();    public N endPolicyBinding();
}
    public interface PolicyBindingListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PolicyBindingListFluent<KubeSchemaFluent.PolicyBindingListNested<N>>{

        
    public N and();    public N endPolicyBindingList();
}
    public interface PolicyListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,PolicyListFluent<KubeSchemaFluent.PolicyListNested<N>>{

        
    public N and();    public N endPolicyList();
}
    public interface ProjectNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ProjectFluent<KubeSchemaFluent.ProjectNested<N>>{

        
    public N and();    public N endProject();
}
    public interface ProjectListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ProjectListFluent<KubeSchemaFluent.ProjectListNested<N>>{

        
    public N and();    public N endProjectList();
}
    public interface ProjectRequestNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ProjectRequestFluent<KubeSchemaFluent.ProjectRequestNested<N>>{

        
    public N and();    public N endProjectRequest();
}
    public interface QuantityNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,QuantityFluent<KubeSchemaFluent.QuantityNested<N>>{

        
    public N and();    public N endQuantity();
}
    public interface ReplicaSetNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ReplicaSetFluent<KubeSchemaFluent.ReplicaSetNested<N>>{

        
    public N and();    public N endReplicaSet();
}
    public interface ReplicaSetListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ReplicaSetListFluent<KubeSchemaFluent.ReplicaSetListNested<N>>{

        
    public N and();    public N endReplicaSetList();
}
    public interface ReplicationControllerListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ReplicationControllerListFluent<KubeSchemaFluent.ReplicationControllerListNested<N>>{

        
    public N and();    public N endReplicationControllerList();
}
    public interface ResourceQuotaNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ResourceQuotaFluent<KubeSchemaFluent.ResourceQuotaNested<N>>{

        
    public N and();    public N endResourceQuota();
}
    public interface ResourceQuotaListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ResourceQuotaListFluent<KubeSchemaFluent.ResourceQuotaListNested<N>>{

        
    public N and();    public N endResourceQuotaList();
}
    public interface RoleNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,RoleFluent<KubeSchemaFluent.RoleNested<N>>{

        
    public N and();    public N endRole();
}
    public interface RoleBindingNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,RoleBindingFluent<KubeSchemaFluent.RoleBindingNested<N>>{

        
    public N and();    public N endRoleBinding();
}
    public interface RoleBindingListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,RoleBindingListFluent<KubeSchemaFluent.RoleBindingListNested<N>>{

        
    public N and();    public N endRoleBindingList();
}
    public interface RoleBindingRestrictionNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,RoleBindingRestrictionFluent<KubeSchemaFluent.RoleBindingRestrictionNested<N>>{

        
    public N and();    public N endRoleBindingRestriction();
}
    public interface RoleListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,RoleListFluent<KubeSchemaFluent.RoleListNested<N>>{

        
    public N and();    public N endRoleList();
}
    public interface RootPathsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,RootPathsFluent<KubeSchemaFluent.RootPathsNested<N>>{

        
    public N and();    public N endRootPaths();
}
    public interface RouteNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,RouteFluent<KubeSchemaFluent.RouteNested<N>>{

        
    public N and();    public N endRoute();
}
    public interface RouteListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,RouteListFluent<KubeSchemaFluent.RouteListNested<N>>{

        
    public N and();    public N endRouteList();
}
    public interface ScaleNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ScaleFluent<KubeSchemaFluent.ScaleNested<N>>{

        
    public N and();    public N endScale();
}
    public interface SecretNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,SecretFluent<KubeSchemaFluent.SecretNested<N>>{

        
    public N and();    public N endSecret();
}
    public interface SecretListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,SecretListFluent<KubeSchemaFluent.SecretListNested<N>>{

        
    public N and();    public N endSecretList();
}
    public interface SecurityContextConstraintsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,SecurityContextConstraintsFluent<KubeSchemaFluent.SecurityContextConstraintsNested<N>>{

        
    public N and();    public N endSecurityContextConstraints();
}
    public interface SecurityContextConstraintsListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,SecurityContextConstraintsListFluent<KubeSchemaFluent.SecurityContextConstraintsListNested<N>>{

        
    public N and();    public N endSecurityContextConstraintsList();
}
    public interface ServiceAccountNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ServiceAccountFluent<KubeSchemaFluent.ServiceAccountNested<N>>{

        
    public N and();    public N endServiceAccount();
}
    public interface ServiceAccountListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ServiceAccountListFluent<KubeSchemaFluent.ServiceAccountListNested<N>>{

        
    public N and();    public N endServiceAccountList();
}
    public interface ServiceListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ServiceListFluent<KubeSchemaFluent.ServiceListNested<N>>{

        
    public N and();    public N endServiceList();
}
    public interface StatefulSetNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,StatefulSetFluent<KubeSchemaFluent.StatefulSetNested<N>>{

        
    public N and();    public N endStatefulSet();
}
    public interface StatefulSetListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,StatefulSetListFluent<KubeSchemaFluent.StatefulSetListNested<N>>{

        
    public N and();    public N endStatefulSetList();
}
    public interface StatusNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,StatusFluent<KubeSchemaFluent.StatusNested<N>>{

        
    public N and();    public N endStatus();
}
    public interface StorageClassNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,StorageClassFluent<KubeSchemaFluent.StorageClassNested<N>>{

        
    public N and();    public N endStorageClass();
}
    public interface StorageClassListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,StorageClassListFluent<KubeSchemaFluent.StorageClassListNested<N>>{

        
    public N and();    public N endStorageClassList();
}
    public interface ModelSubjectAccessReviewNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.openshift.api.model.SubjectAccessReviewFluent<KubeSchemaFluent.ModelSubjectAccessReviewNested<N>>{

        
    public N and();    public N endModelSubjectAccessReview();
}
    public interface SubjectAccessReviewResponseNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,SubjectAccessReviewResponseFluent<KubeSchemaFluent.SubjectAccessReviewResponseNested<N>>{

        
    public N and();    public N endSubjectAccessReviewResponse();
}
    public interface TagEventNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,TagEventFluent<KubeSchemaFluent.TagEventNested<N>>{

        
    public N and();    public N endTagEvent();
}
    public interface TemplateNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,TemplateFluent<KubeSchemaFluent.TemplateNested<N>>{

        
    public N and();    public N endTemplate();
}
    public interface TemplateListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,TemplateListFluent<KubeSchemaFluent.TemplateListNested<N>>{

        
    public N and();    public N endTemplateList();
}
    public interface ThirdPartyResourceNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ThirdPartyResourceFluent<KubeSchemaFluent.ThirdPartyResourceNested<N>>{

        
    public N and();    public N endThirdPartyResource();
}
    public interface ThirdPartyResourceListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ThirdPartyResourceListFluent<KubeSchemaFluent.ThirdPartyResourceListNested<N>>{

        
    public N and();    public N endThirdPartyResourceList();
}
    public interface TokenReviewNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,TokenReviewFluent<KubeSchemaFluent.TokenReviewNested<N>>{

        
    public N and();    public N endTokenReview();
}
    public interface TolerationNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,TolerationFluent<KubeSchemaFluent.TolerationNested<N>>{

        
    public N and();    public N endToleration();
}
    public interface TypeMetaNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,TypeMetaFluent<KubeSchemaFluent.TypeMetaNested<N>>{

        
    public N and();    public N endTypeMeta();
}
    public interface UserNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,UserFluent<KubeSchemaFluent.UserNested<N>>{

        
    public N and();    public N endUser();
}
    public interface UserListNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,UserListFluent<KubeSchemaFluent.UserListNested<N>>{

        
    public N and();    public N endUserList();
}
    public interface WatchEventNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,WatchEventFluent<KubeSchemaFluent.WatchEventNested<N>>{

        
    public N and();    public N endWatchEvent();
}


}
