package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.model.ObjectMeta;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.kubernetes.api.builder.Fluent;
import io.fabric8.kubernetes.api.builder.Nested;
import io.fabric8.kubernetes.api.model.validators.CheckObjectMeta;
import java.lang.String;
import io.fabric8.kubernetes.api.model.ObjectMetaBuilder;
import javax.validation.constraints.NotNull;
import io.fabric8.kubernetes.api.model.ObjectMetaFluent;
import java.lang.Deprecated;
import javax.validation.Valid;
import java.lang.Object;
import java.lang.Boolean;
import java.util.Map;

public interface RoleBindingRestrictionFluent<A extends RoleBindingRestrictionFluent<A>> extends Fluent<A>{


    public String getApiVersion();
    public A withApiVersion(String apiVersion);
    public Boolean hasApiVersion();
    public String getKind();
    public A withKind(String kind);
    public Boolean hasKind();
    
/**
 * This method has been deprecated, please use method buildMetadata instead.
 */
@Deprecated public ObjectMeta getMetadata();
    public ObjectMeta buildMetadata();
    public A withMetadata(ObjectMeta metadata);
    public Boolean hasMetadata();
    public RoleBindingRestrictionFluent.MetadataNested<A> withNewMetadata();
    public RoleBindingRestrictionFluent.MetadataNested<A> withNewMetadataLike(ObjectMeta item);
    public RoleBindingRestrictionFluent.MetadataNested<A> editMetadata();
    public RoleBindingRestrictionFluent.MetadataNested<A> editOrNewMetadata();
    public RoleBindingRestrictionFluent.MetadataNested<A> editOrNewMetadataLike(ObjectMeta item);
    
/**
 * This method has been deprecated, please use method buildSpec instead.
 */
@Deprecated public RoleBindingRestrictionSpec getSpec();
    public RoleBindingRestrictionSpec buildSpec();
    public A withSpec(RoleBindingRestrictionSpec spec);
    public Boolean hasSpec();
    public RoleBindingRestrictionFluent.SpecNested<A> withNewSpec();
    public RoleBindingRestrictionFluent.SpecNested<A> withNewSpecLike(RoleBindingRestrictionSpec item);
    public RoleBindingRestrictionFluent.SpecNested<A> editSpec();
    public RoleBindingRestrictionFluent.SpecNested<A> editOrNewSpec();
    public RoleBindingRestrictionFluent.SpecNested<A> editOrNewSpecLike(RoleBindingRestrictionSpec item);

    public interface MetadataNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ObjectMetaFluent<RoleBindingRestrictionFluent.MetadataNested<N>>{

        
    public N and();    public N endMetadata();
}
    public interface SpecNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,RoleBindingRestrictionSpecFluent<RoleBindingRestrictionFluent.SpecNested<N>>{

        
    public N and();    public N endSpec();
}


}
